(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)









Off[General::spell];
Off[General::spell1];
Off[Power::infy];
Off[Solve::svars];
Off[ArcTan::indet];

BeginPackage["OptimizationToolbox`CommonFunctions`"];

ConvergenceTolerance::usage="ConvergenceTolerance is an option for most optimization methods. Most methods require only a single zero tolerance value. Some interior point methods require a list of convergence tolerance values.";

UnrestrictedVariables::usage="UnrestrictedVariables is an option for LP and several QP problems. A list of variables that are not restricted to be positive can be specified with this option. Default is {}.";

MaxIterations::usage ="MaxIterations is an option for several optimization methods. It specifies the maximum number of iterations allowed.";

ProblemType::usage = "ProblemType is an option for most optimization methods. It can either be Min (default) or Max.";

StandardVariableName::usage="StandardVariableName is an option for LP and QP methods. It specifies the symbol to be used when creating variable names during conversion to the standard form. The default is x.";

PrintLevel::usage="PrintLevel is an option for most functions in the OptimizationToolbox. It is specified as an integer. The value of the integer indicates how much intermediate information is to be printed. A PrintLevel->0 suppresses all printing. The default for most functions is set to 1, in which case they print only the initial problem setup. Higher integers print more intermediate results.";



mySubscript::usage="mySubscript[a,i]: calls Subscript with arguments converted to strings. Fixes problem with subscripted variables on some computers.";

RemoveRowColumn::usage="RemoveRowColumn[a,i]: Given a square matrix, returns the matrix after removing the ith row and column. RemoveRowColumn[a,i, j], returns the matrix after removing the ith row and jth column.";

OptionsUsage::usage="OptionsUsage[f]: Shows all options and their usage messages for function f.";

Norm::usage = "Norm[v], computes norm of vector v.";

Grad::usage = "Grad[f, vars], computes gradient of function f (or a list of functions) with respect to variables vars. Grad[f, vars, pt] returns gradient at given pt using finite difference approximation.";

Hessian::usage = "Hessian[f,vars], computes Hessian matrix of function f (or a list of functions).";

StandardConstraints::usage="StandardConstraints[cons]: Converts constraints to g\[LessEqual]0 and h==0 format. Any duplicate constraints are eliminated. Constraints not in the form of an equation or inequality are ignored.";

PrintLabelledList::usage="PrintLabelledList[f,labels,n], prints a list of functions with their specified labels. The format is lab1->f1, lab2->f2, \[Ellipsis].n specifies the maximum number of items to print in one row ( default is 3).";

Rank::usage="Rank[a_], returns rank of matrix a.";



PrincipalMinors::usage="PrincipalMinors[A], returns Principal minors of a matrix A.";

QuadraticFormSign::usage="QuadraticFormSign[A], determines the sign of a quadratic form involving symmetric matrix A using principal minors test. It returns the sign (positive definite, etc.) and the principal minors of A."; 



ConvexityCheck::usage="ConvexityCheck[f,vars], checks to see if function f (or a list of functions f) is convex.";



Begin["`Private`"];

Needs["LinearAlgebra`MatrixManipulation`"];
Needs["NumericalMath`NLimit`"];
Needs["Utilities`FilterOptions`"];



mySubscript[a_,i_]:=Subscript[ToString[a],ToString[i]];
(*fixes a problem with subscripted variables on some machines*)



RemoveRowColumn[a_,r_List]:=RemoveRowColumn[a,r[[1]]];
RemoveRowColumn[a_,r_]:=Module[{n=Length[a],na},
	na=AppendRows[TakeColumns[a,{1,r-1}],TakeColumns[a,{r+1,n}]];
	na=Join[TakeRows[na,{1,r-1}],TakeRows[na,{r+1,n}]];
	na
];
RemoveRowColumn[a_,r_,c_]:=Module[{n=Length[a],na},
	na=Transpose[Transpose[a][[Complement[Range[n],{c}]]]];
	na[[Complement[Range[n],{r}]]]
]

OptionsUsage[f_]:=
Module[{opts=Options[f]},
	Print[opts];
	Map[ToExpression["?"<>ToString[#[[1]]]]&,opts];
]

Norm[v_] := N[Sqrt[v . v]];

Grad[f_List,vars_] := Map[Grad[#,vars]&, f];
Grad[f_,vars_] := Map[Expand[D[f,#]]&, vars];
Grad[f_List, vars_, pt_] := Map[Grad[#,vars, pt]&, f];
Grad[f_,vars_,pt_]:=
  Map[ND[(f/.Thread[Drop[vars,{#}]->Drop[pt,{#}]]),vars[[#]],pt[[#]]]&,
    Range[Length[vars]]]; 

Hessian[f_List,vars_] := Map[Hessian[#,vars]&, f];
Hessian[f_, vars_] := Map[D[Grad[f,vars], #]&,vars];

StandardConstraints[con_List]:=Module[{c=Flatten[con],LE,GE,EQ},
	isolate[a_,b_]:= Flatten[Map[Cases[a,#]&,b]];
	bringToLeft[a_]:= Map[First[#]-Last[#]&,a];
	LE = isolate[c,{_LessEqual, _Less}];
	GE = isolate[c,{_Greater,_GreaterEqual}];
	EQ = isolate[c,{_Equal}];
	rest = Complement[c, LE, GE, EQ]; 
	LE = Join[rest,bringToLeft[LE],-bringToLeft[GE]];
	EQ = bringToLeft[EQ];
	{LE,EQ}
]		

PrintLabelledList[f_List,labels_List]:=
	PrintLabelledList[f,labels,3];
PrintLabelledList[f_List,labels_List,n_]:=
Module[{g},
	g = group[Range[Length[f]],n];
	Map[printLabelled[f[[#]],labels[[#]]]&,g];
];
group[a_,n_]:=Module[{b,c},
	b=Partition[a,n];
	c=Drop[a,Length[Flatten[b]]];
	If[c!={},AppendTo[b,c],b]
];
printLabelled[f_List,labels_List]:=
Module[{lab},
	lab[x_,y_]:=x->y;
	Print[TableForm[Thread[lab[labels,
		Map[If[Or[(#!={} && VectorQ[#]),(#!={{}} && MatrixQ[#])],
			MatrixForm[#],#]&,f]]],TableDirections->{Row,Column}]];
];

Rank[a_]:= Module[{red,size,rnk,nz,i,j},
	rnk= 0;
	size= Dimensions[a];
	red= RowReduce[a];
	Do[ nz= False;
		Do[If [red[[i,j]]!= 0, nz= True], 
			{j,size[ [2] ]}
		];
 		If [nz, rnk = rnk + 1],
 		{i, size[ [1] ]}
	];
	rnk
 ];



PrincipalMinors[a_]:=
	Map[Det[TakeColumns[TakeRows[a,#],#]]&,Range[Length[a]]]

QuadraticFormSign[a_]:=
Module[{pm,status="Indefinite",oddPm,evenPm},
	pm=PrincipalMinors[a];
	oddPm=pm[[Select[Range[Length[a]],OddQ]]];
	evenPm=pm[[Select[Range[Length[a]],EvenQ]]];
	Which[Min[pm]>0,status="PositiveDefinite",
		Min[pm]>=0,status="PositiveSemiDefinite",
		Min[pm]>0,status="PositiveDefinite",
		And[Min[evenPm]>0,Max[oddPm]<0],status="NegativeDefinite",
		And[Min[evenPm]>=0,Max[oddPm]<=0],status="NegativeSemiDefinite"];
		PrintLabelledList[{pm,status},
		{"Principal minors","Quadratic form"},1];
		{status, pm}
];		



ConvexityCheck[f_List,vars_List]:=
	Map[ConvexityCheck[#,vars]&,
		Flatten[StandardConstraints[f]]];

ConvexityCheck[f_,vars_List]:=
Module[{H, pm,status="Indefinite"},
	H=Hessian[f,vars];
	pm=PrincipalMinors[H];
	If[And @@ Map[NumericQ, pm], 
		If[Min[pm]>=0,status="Convex",status="NonConvex"],
		status="Undetermined"
	];
	PrintLabelledList[{f},{"------ Function"}];
	PrintLabelledList[{H,pm,status},
		{"Hessian","Principal Minors","Status"},2];
	status
];



End[];

EndPackage[]