(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)









BeginPackage["OptimizationToolbox`ConstrainedNLP`",
"OptimizationToolbox`CommonFunctions`"];
Off[ConstrainedMin::nbddt];
Off[ConstrainedMin::nsatt];

Needs["OptimizationToolbox`QuadraticProgramming`"];
Needs["OptimizationToolbox`Unconstrained`"];



ALPF::usage = "ALPF[f, cons, vars, pt, opts] solves a constrained optimization problem using the augmented Lagrangian penalty function method. f = objective function. cons = list of constraints. vars = list of problem variables. pt = starting point. opts = options allowed by the function. See Options[ALPF] to see all valid options.";  

Options[ALPF] = {
	ProblemType->Min,
	PrintLevel->1,
	Gradient->Automatic,
	MaxIterations->20,
	ConvergenceTolerance->0.001,
	SolveUnconstrainedUsing->FindMinimum,
	MaxUnconstrainedIterations->50, 
	PenaltyParameters->{10,2}
	};

Gradient::usage = "Gradient is an option for several optimization algorithms. It specifies whether the gradient vector is to be computed automatically by direct differentiation (Gradient->Automatic) or by using finite differences (Gradient->Numerical). Analytical gradient vector can be given by entering Gradient->{grad vector}. The default is Automatic.";

SolveUnconstrainedUsing::usage = "SolveUnconstrainedUsing is an option for the ALPF method. It defines the solution method used for solving the unconstrained subproblem. The default is the built-in FindMinimum function.";

MaxUnconstrainedIterations::usage = "MaxUnconstrainedIterations is an option for the ALPF method. It defines the maximum number of iterations allowed in solving the unconstrained problem. The default is MaxUnconstrainedIterations->50.";

PenaltyParameters::usage = "PenaltyParameters is an option for the ALPF method. It defines the starting value for parameter \[Mu] and scale factor for changing it during iterations. The default values are PenaltyParameters->{10,2}";

ALPF::"Fail" = "Failed to solve unconstrained problem at point `1`.";



Linearize::usage = "Linearize[f,fLabels,vars,pt,dvars], Linearize function f(vars) at given point (pt). fLabels are used to identify the linearized functions. The results are returned in terms of dvars and original vars.";



SLP::usage = "SLP[f, con, vars, x0, opts]. Computes minimum of f(vars) subjected to specified 'con'straints starting from x0 using SLP method. LP subproblem is solved using built-in Mathematica function ConstrainedMin. See Options[SLP] to see a list of options for the function. The function returns {x, hist}. 'x' is either the optimum point or the next point after MaxIterations. 'hist' contains history of values tried at different iterations.";

Options[SLP] = {
	PrintLevel->1,MaxIterations->10,
	ConvergenceTolerance->0.001, DirVarName->"d",
	MoveLimit->0.5};

DirVarName::usage = "DirVarName is an option for SLP. It defines the variable name to be used for defining direction. Default DirVarName->d.";

MoveLimit::usage = "MoveLimit is an option for SLP. It defines the MoveLimit parameter \[Beta]. Default MoveLimit->0.5.";

SLP::"moveLimit" = "Changing move limit factor (\[Beta]) to `1`.";



GenerateQP::usage = "GenerateQP[f, g_List, h_List,vars,pt, dvars] generates an QP subproblem for direction finding by linearizing f, g, and h functions. vars is a list of actual variables. dvars is a list of variables to be used in the direction finding problem. moveLimits are specified individually for each design variable.";



SQP::usage = "SQP[f, cons, vars, pt, opts] solves a constrained optimization problem using the SQP algorithm. f = objective function. cons = list of constraints. vars = list of problem variables. pt = starting point. opts = options allowed by the function. See Options[SQP] to see all valid options.";  

Options[SQP] = {
	ProblemType->Min,
	PrintLevel->1, MaxIterations->10,
	ConvergenceTolerance->0.001,
	SolveQPUsing->"ActiveSetDual",
	MaxQPIterations->20, 
	StartingMu->10,
	LineSearchGamma->0.5,
	MaxLineSearchIterations->10
	};

SolveQPUsing::usage = "SolveQPUsing is an option for the SQP & RSQP methods. It defines the solution method used for solving the QP subproblem. Currently the choice is between the ActiveSet and the ActiveSetDual for the SQP and between the ActiveSet and the PrimalDual for the RSQP. The default is SolveQPUsing->ActiveSetDual for the SQP and the PrimalDual for the RSQP.";

MaxQPIterations::usage = "MaxQPIterations is an option for the SQP method. It defines the maximum number of iterations allowed in solving the the QP subproblem. The default is MaxQPIterations->20.";

StartingMu::usage = "StartingMu is an option for the SQP method. It defines the starting value of the penalty parameter \[Mu] used in establishing the merit function. The default is StartingMu->10";

LineSearchGamma::usage = "LineSearchGamma is an option for the SQP and the RSQP methods. It defines the value of the parameter \[Gamma] used with the approximate line search. The default is LineSearchGamma->0.5";

MaxLineSearchIterations::usage = "MaxLineSearchIterations is an option for the SQP method. It defines the maximum number of iterations allowed during the line search. The default is MaxLineSearchIterations->10.";

SQP::"Restart" = "Restart condition occurred at iteration `1`. Current point -> `2`, \[Mu] -> `3`, \[Phi] with old \[Mu] -> `4`, and \[Phi] with new \[Mu] -> `5`.";

SQP::"QPFailed" = "QP failed: status -> `1`, current point `2`.";

Step::"TooSmall" = "Step-length smaller than `1`.";

Step::"NoConvergence" = "Approximate step length procedure did not converge. Smallest step tried `1`.";



RSQP::usage = "RSQP[f, cons, vars, pt, opts] solves a constrained optimization problem using the RSQP algorithm. f = objective function. cons = list of constraints. vars = list of problem variables. pt = starting point. opts = options allowed by the function. See Options[RSQP] to see all valid options.";

Options[RSQP] = {
	ProblemType->Min,
	PrintLevel->1, 
	Gradient->Automatic,
	MaxIterations->10,
	ConvergenceTolerance->0.01,
	SolveQPUsing->"PrimalDual",
	QPConstraintFactor->0.9,
	MaxQPIterations->20,
	ResetQPHessian->"Never", 
	LineSearchDelta->0.1,
	LineSearchGamma->0.5,
	StepLengthUsing->"ApproximateLineSearch",
	MaxLineSearchIterations->20
	};

QPConstraintFactor::usage = "QPConstraintFactor is an option for the RSQP method. It defines the constraint value reduction factor (r) used in the QP subproblem formulation. The default is QPConstraintFactor->0.9.";

ResetQPHessian::usage = "ResetQPHessian is an option for the RSQP method. It defines the number of iterations after which the hessian should be reset to the identity matrix. The default is ResetQPHessian->Never.";

LineSearchDelta::usage = "LineSearchDelta is an option for the RSQP method. It defines the value of the parameter \[Delta] used during the line search using the quadratic interpolation. The default is LineSearchDelta->0.1";

StepLengthUsing::usage = "StepLengthUsing is an option for the RSQP method. It specifies the method used for computing step length. The options are ApproximateLineSearch (default), GoldenSectionSearch and QuadraticSearch.";



Begin["`Private`"];

Needs["Utilities`FilterOptions`"];
Needs["LinearAlgebra`MatrixManipulation`"];





ALPF[fs_, con_List, vars_, pt_, opts___?OptionQ] :=
Module[{ newpt = pt, eps, maxIter, iter=0,prevMaxViolation, maxViolation, 
	history={{"Point","f", "maxViolation"}},fLabel="f",
	gLabels={},hLabels={}, g={}, h={}, prSetup,
	df,dg={},dh={},dfLabel="\[Del]f",dgLabels={}, dhLabels={},
	Converged=False,prResults, fpt, gpt, hpt, \[Phi], d\[Phi], 
	unconstMethod, type, f,prevf, stepPrint, rpt,
	maxUnconstIter, histPrint, unconstDetails, \[Mu], c, u, v, r, sol, gradient},
	{type, prResults, gradient, maxIter, eps, 
		unconstMethod, maxUnconstIter,{\[Mu], c}} = {ProblemType,
		PrintLevel, Gradient, MaxIterations,
		ConvergenceTolerance,SolveUnconstrainedUsing,
		MaxUnconstrainedIterations, PenaltyParameters}/.
			Flatten[{opts, Options[ALPF]}];
	Switch[prResults,
		0, {prSetup, histPrint, stepPrint, unconstDetails} = 
			{False, False, False, False},
		1, {prSetup,histPrint, stepPrint, unconstDetails} = 
			{True, False, False, False},
		2, {prSetup,histPrint, stepPrint, unconstDetails} = 
			{True, True, False, False},
		3, {prSetup,histPrint, stepPrint, unconstDetails} = 
			{True, True, True, False},
		_, {prSetup,histPrint, stepPrint, unconstDetails} = 
			{True, True, True, True}
	];
	If[And[ToString[gradient]==="Numerical", unconstMethod===FindMinimum],
		unconstMethod=ConjugateGradient];
	If[type===Max,f=-fs,f=fs];
	Switch[ToString[gradient],
		"Automatic", df=Grad[f,vars],
		"Numerical", df="Numerical",
		_, df=gradient[[1]]
	];
	{g,h} = StandardConstraints[con];
	If[g!={},
		gLabels = Table["g"<>ToString[i],{i,1,Length[g]}];
		dgLabels=Map["\[Del]"<>#&,gLabels];
		Switch[ToString[gradient],
			"Automatic", dg=Grad[g,vars],
			"Numerical", dg=Table["Numerical",{Length[g]}],
			_, dg=Take[Drop[gradient,1],Length[g]]
		];
	];
	If[h!={},
		hLabels = Table["h"<>ToString[i],{i,1,Length[h]}];
		dhLabels=Map["\[Del]"<>#&,hLabels];
		Switch[ToString[gradient],
			"Automatic", dh=Grad[h,vars],
			"Numerical", dh=Table["Numerical",{Length[h]}],
			_, dh=Take[Drop[gradient,1+Length[g]],Length[h]]
		];
	];
	If[prSetup,
		PrintLabelledList[{f,{df}},{"Minimize "<>fLabel,dfLabel},1];
		If[g!={},
			PrintLabelledList[{Thread[g\[LessEqual]0],dg},
			{"LE Constraints: "MatrixForm[gLabels],MatrixForm[dgLabels]},1]
		];
		If[h!={},
			PrintLabelledList[{Thread[h==0],dh},
			{"EQ Constraints: "MatrixForm[hLabels],MatrixForm[dhLabels]},1]
		]
	];
	u = Table[0, {Length[g]}];
	v = Table[0, {Length[h]}];
	rpt = u;
	{fpt, gpt, hpt} = {f,g,h} /.ToRules[vars==newpt];   
	maxViolation = Max[0, gpt, Abs[hpt]]; 
	prevMaxViolation = 10^10;
	AppendTo[history, {newpt, fpt, maxViolation}];
	While [And[++iter <= maxIter,Not[Converged]],
		If[histPrint,
			StylePrint["------------------ ALPF Iteration "<>
			ToString[iter]<>
			" ------------------","Output",FontWeight->"Bold"];
			PrintLabelledList[{{newpt}, 
				MatrixForm[{fpt, gpt, hpt}], maxViolation},
				{"Current point", 
				"Function values"MatrixForm[{"f","g","h"}],
			"Max Violation"},1];
		];
		If[stepPrint,
			PrintLabelledList[{\[Mu],v,rpt,u},{"\[Mu]","v","r","u"},2]
		];
		r = Map[Max[#,0]&,g+(u/(2\[Mu]))];
		\[Phi] = Expand[f + v.h + \[Mu] Apply[Plus,h^2] 
			+ \[Mu] Apply[Plus,r^2] - Apply[Plus,(u^2)/(4\[Mu])]];
		If[ToString[gradient]==="Numerical", 
			d\[Phi]="Numerical",
			d\[Phi] = Expand[df + v.dh + 2\[Mu] h.dh + \[Mu] 2 r.dg] 
		];
		If[unconstDetails,
			PrintLabelledList[{\[Phi], d\[Phi]},
			{"\[Phi]","\[Del]\[Phi]"},1]
		];
		If[unconstMethod===FindMinimum,
			sol = FindMinimum[Evaluate[\[Phi]], Evaluate[Apply[Sequence,
			Transpose[{vars,newpt}]]], 
			Evaluate[Gradient->d\[Phi]],MaxIterations->maxUnconstIter,
			Evaluate[FilterOptions[FindMinimum,opts]],AccuracyGoal->1],
			sol=unconstMethod[Evaluate[\[Phi]], vars, newpt,
				Gradient->d\[Phi], MaxIterations->maxUnconstIter,
				PrintLevel->If[unconstDetails,2,0],
				FilterOptions[unconstMethod,opts]][[1]]
		];
		If[Or[Head[sol]===unconstMethod,Not[NumericQ[sol[[1]]]]],
			Message[ALPF::"Fail",newpt];
			PrintLabelledList[{sol},{"Solution"},1];
			Abort[]
		];
		If[stepPrint,
			PrintLabelledList[{sol},{"Solution"},1]
		];
		newpt = vars/.sol[[2]];
		prevf = fpt;
		{fpt, gpt, hpt} = {f,g,h} /.ToRules[vars==newpt];
		maxViolation = Max[0, gpt, Abs[hpt]];
		AppendTo[history, {newpt,fpt,maxViolation}];
		If[Max[maxViolation,Abs[(prevf-fpt)/fpt]]\[LessEqual]eps,
			Converged=True,
			If[And[maxViolation>0,maxViolation\[LessEqual]prevMaxViolation/4],
				prevMaxViolation = maxViolation;
				rpt = Map[Max[#,0]&,gpt+(u/(2\[Mu]))];
				v = v + 2 \[Mu] hpt; 
				u = u + 2 \[Mu] rpt,
				\[Mu] = c \[Mu]
			]; 
		];
	];
	sol = Thread[vars->newpt];
	If[prSetup,
    	If [Converged, 
			PrintLabelledList[{iter-1},
			{"Optimum point: Iterations performed"},1],
			PrintLabelledList[{iter-1},
			{"NonOptimum point: Iterations performed"},1]
		];
		PrintLabelledList[{{sol}, MatrixForm[{fpt, gpt, hpt}]},
		{"Point", "Function values"MatrixForm[{"f","g","h"}]},1];
		PrintLabelledList[{\[Mu],maxViolation,v,u},
		{"\[Mu]","Max Violation","v","u"},2]
	];
	{{fpt, sol, If[Converged, "Optimum", "NonOptimum"]}, history} 
];



Linearize[ff_List,ffLabels_List, vars_,pt_,dvars_] := 
Module[{lp, gradf, fPoint, gradfPoint,lpx,
lpVars = ToRules[dvars==vars - pt],ptRule = ToRules[vars==pt],
gradientLabels, linearLabels, f = Flatten[ff], fLabels=Flatten[ffLabels]},
	gradientLabels=Map["\[Del]"<>#&,fLabels]; 
	linearLabels=Map[OverTilde,fLabels];
	gradf=Grad[f,vars];
	{lp, fPoint, gradfPoint} = Transpose[Map[Linearize[
		f[[#]],gradf[[#]],ptRule,dvars]&,Range[Length[f]]]];
	lpx = Expand[lp/.lpVars];
	Print["***** Gradient vectors"];
	PrintLabelledList[gradf,gradientLabels];
	Print["***** Function values at"->pt];
	PrintLabelledList[fPoint,fLabels];
	Print["***** Gradient vectors at"->pt];
	PrintLabelledList[gradfPoint,gradientLabels];
	Print["***** Linearized functions at"->pt];
	PrintLabelledList[lp,linearLabels,1];
	Print["***** In terms of original variables"->lpVars];
	PrintLabelledList[lpx,linearLabels,1];
	{lp,lpx}
]
Linearize[f_,df_,lpt_,dvars_] := Module[{fPoint, gradfPoint},
	fPoint = f/.lpt;
	gradfPoint = df /. lpt;
	{fPoint + gradfPoint . dvars, fPoint, gradfPoint}
]

(*RemoveConstantTerm[f, vars], takes a linear function of f(vars) and returns the function without the constant term.*)
RemoveConstantTerm[f_, vars_] := Map[Coefficient[f,#]&,vars] . vars;

LinearizeAll[f_,df_,fLabels_,dfLabels_,vars_,pt_,dvars_,prResults_] := 
Module[{lp, fPoint, gradfPoint,ptRule, gradientLabels, linearLabels},
	linearLabels=Map[OverTilde,fLabels];
	ptRule = ToRules[vars==pt];
	{lp, fPoint, gradfPoint} = Transpose[Map[Linearize[
		f[[#]],df[[#]],ptRule,dvars]&,Range[Length[f]]]];
	If[prResults,
		Print["Function values at"->pt];
		PrintLabelledList[fPoint,fLabels];
		Print["Gradient vectors at"->pt];
		PrintLabelledList[gradfPoint,dfLabels];
		Print["Linearized functions at"->pt];
		PrintLabelledList[lp,linearLabels,1];
	];
	lp
]



SLP[f_, con_List, vars_, x0_, opts___Rule] :=
Module[{eps, maxIter, dvarName, dvars, iter=0, move,
lpf, lpg, dir, x = x0, g={},h={},dg={},dh={},
prLevel, prSetup, prResults, sol={}, fstar={},
gLabels={}, hLabels={},dgLabels={}, dhLabels={},
fLabel="f",df,dfLabel="\[Del]f", history={}, status="NonOptimum"}, 
	{prLevel, maxIter, eps, dvarName, move} = 
	{PrintLevel, MaxIterations,
		ConvergenceTolerance,DirVarName,
		MoveLimit} /. Flatten[{opts, Options[SLP]}];
	Switch[prLevel,
		0, {prSetup, prResults}={False, False}, 
		1, {prSetup, prResults}={True, False}, 
		_, {prSetup, prResults}={True, True}
	];
	dvars = Table[mySubscript[dvarName,i],{i,1,Length[vars]}];
	{g,h} = StandardConstraints[con];
	df=Grad[f,vars];
	{g,h} = StandardConstraints[con];
	If[g!={},
		gLabels = Table["g"<>ToString[i],{i,1,Length[g]}];
		dgLabels=Map["\[Del]"<>#&,gLabels];
		dg=Grad[g,vars]
	];
	If[h!={},
		hLabels = Table["h"<>ToString[i],{i,1,Length[h]}];
		dhLabels=Map["\[Del]"<>#&,hLabels];
		dh=Grad[h,vars]
	];
	If[prSetup,
		PrintLabelledList[{f,{df}},{"Minimize "<>fLabel,dfLabel},1];
		If[g!={},
			PrintLabelledList[{Thread[g\[LessEqual]0],dg},
			{"LE Constraints: "MatrixForm[gLabels],MatrixForm[dgLabels]},1]
		];
		If[h!={},
			PrintLabelledList[{Thread[h==0],dh},
			{"EQ Constraints: "MatrixForm[hLabels],MatrixForm[dhLabels]},1]
		]
	];
	AppendTo[history,{"x","||d||"}];
	AppendTo[history,{x,"--"}];
	While[And[status==="NonOptimum", ++iter\[LessEqual]maxIter],
		If[prResults,
			Print["***** Iteration "<>ToString[iter]<>" *****"];
		];
		{lpf, lpg}=GenerateLP[f,df,fLabel,dfLabel,
			g,dg,gLabels,dgLabels,h,dh,hLabels,dhLabels,vars,x, dvars,
			Table[move,{Length[vars]}], prResults];
		dir = SolveSLPdirection[lpf, lpg, dvars];
		Which[
			dir==="Unbounded",move=move/2;
				Message[SLP::"moveLimit",move],
			dir==="Infeasible",move=2*move;
				Message[SLP::"moveLimit",move],
			True, If[Norm[dir]\[LessEqual]eps, status="Optimum"];
			x = x + dir;
			AppendTo[history,{x,Norm[dir]}];
			If[prResults,PrintLabelledList[{dir,x},
			{"Direction","New point"}]]
		];
	];
	sol = Thread[vars->x];
	fstar = f/.sol;
	If[prSetup,
		If[status==="Optimum",
			Print["Optimum: ",sol, " after ", iter," iterations"],
			Print["New Point (Non-Optimum): ",sol,
			" after ",iter-1, " iterations"]
		]
	];
	{{fstar, sol, status},history}
];

GenerateLP[f_,df_,fLabel_,dfLabel_, g_,dg_,gLabels_,dgLabels_, h_,dh_,hLabels_,dhLabels_,vars_,pt_, dvars_, moveLimits_,prResults_] := 
Module[{lin, lpf, lpg = {}, lph ={}, n=Length[vars]},
	lin = LinearizeAll[Join[{f},g,h],Join[{df},dg,dh],
		Join[{fLabel},gLabels,hLabels],
		Join[{dfLabel},dgLabels,dhLabels],vars,pt,dvars,prResults];
	lpf = RemoveConstantTerm[lin[[1]], dvars];
	If [ g != {},
			lpg = Table[lin[[i+1]]\[LessEqual]0,{i,1,Length[g]}]
	];
	lpg = {lpg,Table[
			dvars[[i]]-moveLimits[[i]] pt[[i]]\[LessEqual]0,{i,1,n}]};
	lpg = {lpg,Table[
				If[pt[[i]]!=0,-dvars[[i]]-moveLimits[[i]]pt[[i]]]\[LessEqual]0,
				{i,1,n}]};
	lpg = Flatten[lpg];
	If [ h != {},
		lph = {lph,Table[lin[[i+1+Length[g]]]==0,
		{i,1,Length[h]}]}
	];
						
	lph = Flatten[lph];
	If[prResults,
		Print["-------Complete LP subproblem-------"];
		Print["Minimize ",lpf];
		Print["Subject to "->MatrixForm[Join[lpg, lph]]]
	];
	{lpf, Join[lpg, lph]}
]						

(*SolveSLPdirection::usage = "SolveSLPdirection[f, g, vars], solves the direction finding problem associated with SLP using the 'ConstrainedMin function'. f, g, and h are linearized objective, inequality and equality constraints functions.
vars is a list of variables of the direction finding problem.";*)
SolveSLPdirection[f_, g_, vars_] :=
Module[{y, dv, nf, ng, soln},
	(*	Needs["OptimizationToolbox`LPSimplex`"];
		soln = RevisedSimplex[f, g, vars,
		UnrestrictedVariables->vars, PrintLevel->0];
	soln = vars/.soln[[2]] *)
	dv = Array[y, 2*Length[vars]];
    nf = ConvertUnrestricted[f, vars, Range[Length[dv]],dv];
    ng = Map[ConvertUnrestricted[#, vars, Range[Length[dv]],dv]&,g];
	soln = ConstrainedMin[nf, ng, dv];
	If[Not[NumericQ[soln[[1]]]],
		If[soln[[1]]===-\[Infinity],soln="Unbounded",soln="Infeasible"],
		soln = Apply[Subtract,Transpose[Partition[dv,2]]]/. soln[[2]]
	];
	soln
];

ConvertUnrestricted[fcn_, vars_, unrestrictedVars_, x_] := 
Module[{xv={},p=1,i},
	Do[If[MemberQ[unrestrictedVars,i],
			AppendTo[xv,{vars[[i]]->x[[p]]-x[[p+1]]}];
			p=p+2,
			AppendTo[xv,{vars[[i]]->x[[p]]}];
			p=p+1
		],{i,1,Length[vars]}
	];		
	Map[Expand,fcn /. Flatten[xv]]
]



GenerateQP[f_, con_List, vars_,pt_, dvars_] := 
Module[{lin, qpf, lpg = {}, lph ={}, n=Length[vars],
	fLabel="f",gLabels={},hLabels={}, g={}, h={}},
		{g,h} = StandardConstraints[con];
	If[g!={},
		Print["***** Standardized (g \[LessEqual] 0) constraints"];
		gLabels = Table["g"<>ToString[i],
			{i,1,Length[g]}];PrintLabelledList[g,gLabels]
	];
	If[h!={},
		Print["***** Standardized (h = 0) constraints"];
		hLabels = Table["h"<>ToString[i],
			{i,1,Length[h]}];PrintLabelledList[h,hLabels]
	];
	lin = Linearize[Join[{f},g,h],
		Join[{fLabel},gLabels,hLabels],vars,pt,dvars][[1]];
	qpf = RemoveConstantTerm[lin[[1]],dvars]+
			1/2 dvars . dvars;
	If [ g != {},
		lpg = Table[lin[[i+1]]\[LessEqual]0,{i,1,Length[g]}]
	];
	If [ h != {},
		AppendTo[lph,Table[lin[[i+1+Length[g]]]==0,
		{i,1,Length[h]}]]
	];
						
	lph = Flatten[lph];
	Print["-------Complete QP subproblem-------"];
	Print["Minimize ",qpf];
	Print["Subject to "->MatrixForm[Join[lpg, lph]]];
	{qpf, Map[First,lpg], Map[First,lph]}
]						



SQP[fs_, con_List, vars_, pt_, opts___?OptionQ] :=
Module[{ newpt = pt, qpSoln={}, gamma, eps, maxIter, qpvars,iter=0, 
	history={{"Point","d","||d||","\[Phi]"}},fLabel="f", qpStatus,
	gLabels={},hLabels={}, g={}, h={},prSetup, fstar, sol, 
	df,dg={},dh={},dfLabel="\[Del]f",dgLabels={}, dhLabels={},
	Converged=False,dNorm,prResults,maxLineIter, d, w,
	absWsum, fcnVals, phi, qpMethod, type, f, phiNew,
	maxQpIter,histPrint, qpPrint, qpDetails, stepPrint, stepDetails},
	{type, prResults,maxIter, eps, gamma,\[Mu],
		maxLineIter,qpMethod, maxQpIter} = {ProblemType,
		PrintLevel, MaxIterations,
		ConvergenceTolerance, LineSearchGamma,
		StartingMu, MaxLineSearchIterations,SolveQPUsing,MaxQPIterations}/.
			Flatten[{opts,Options[SQP]}];
	qpMethod = ToString[qpMethod];
	Switch[prResults,
		0, {prSetup, histPrint, qpPrint, qpDetails, 
			stepPrint, stepDetails} = 
			{False, False, False, False, False, False},
		1, {prSetup, histPrint, qpPrint, qpDetails, 
			stepPrint, stepDetails} = 
			{True, False, False, False, False, False},
		2, {prSetup, histPrint, qpPrint, qpDetails, 
			stepPrint, stepDetails} = 
			{True, True, False, False, True, False},
		3, {prSetup, histPrint, qpPrint, qpDetails, 
			stepPrint, stepDetails} = 
			{True, True, True, False, True, False},
		4, {prSetup, histPrint, qpPrint, qpDetails, 
			stepPrint, stepDetails} = 
			{True, True, True, False, True, True},
		_, {prSetup, histPrint, qpPrint, qpDetails, 
			stepPrint, stepDetails} = 
			{True, True, True, True, True, True}
	];
	If[type===Max,f=-fs,f=fs];
	df=Grad[f,vars];
	{g,h} = StandardConstraints[con];
	If[g!={},
		gLabels = Table[mySubscript["g",i],{i,1,Length[g]}];
		dgLabels=Map["\[Del]"#&,gLabels];
		dg=Grad[g,vars]
	];
	If[h!={},
		hLabels = Table[mySubscript["h",i],{i,1,Length[h]}];
		dhLabels=Map["\[Del]"#&,hLabels];
		dh=Grad[h,vars]
	];
	If[prSetup,
		PrintLabelledList[{f,{df}},{"Minimize "<>fLabel,dfLabel},1];
		If[g!={},
			PrintLabelledList[{Thread[g\[LessEqual]0],dg},
			{"LE Constraints: "MatrixForm[gLabels],MatrixForm[dgLabels]},1]
		];
		If[h!={},
			PrintLabelledList[{Thread[h==0],dh},
			{"EQ Constraints: "MatrixForm[hLabels],MatrixForm[dhLabels]},1]
		]
	];
	While [And[++iter <= maxIter,Not[Converged]],
		fcnVals = {f,g,h} /.ToRules[vars==newpt];   
		phi = meritFunction[fcnVals, \[Mu]];
		If[histPrint,
			StylePrint["------------------ SQP Iteration "<>
			ToString[iter]<>
			" ------------------","Output",FontWeight->"Bold"];
			PrintLabelledList[{{newpt}, MatrixForm[fcnVals]},
			{"Current point", "Function values"MatrixForm[
			{"f","g","h"}]},1]
		];
		{{d,w},qpStatus} =SQPDirection[f,g,h,df,dg,dh,vars,newpt,
			qpMethod, maxQpIter, eps, qpPrint, qpDetails];
		If[qpStatus!="Optimum",
			sol = Thread[vars->newpt];
			fstar = f/.sol;
			Message[SQP::"QPFailed", qpStatus, newpt];
			Return[{{fstar, sol, "QPFailed"}, history}]
		];
		absWsum=Apply[Plus,Abs[w]];
		dNorm=Norm[d];
		If[histPrint,
			PrintLabelledList[{{d},dNorm,{w}},
			{"Direction","\[DoubleVerticalBar]d\[DoubleVerticalBar]","Lagrange multipliers"},2]
		];
		AppendTo[history, {newpt,d,dNorm,phi}];
		If[dNorm\[LessEqual]eps,Converged=True,
			If[\[Mu]>absWsum,
				newpt = SQPApproxLineSearch[vars, f, g, h, newpt,
					 d, \[Mu], phi, gamma,maxLineIter,stepPrint, stepDetails],
				\[Mu] = 2 * absWsum;
				phiNew = meritFunction[fcnVals, \[Mu]];
				If[Or[phiNew\[LessEqual]phi, iter===1],
					newpt = SQPApproxLineSearch[vars, f, g, h, newpt,
						 d, \[Mu], phiNew, gamma,
						maxLineIter,stepPrint, stepDetails],
					Message[SQP::"Restart",iter, newpt, \[Mu], phi, phiNew];
					newpt = pt
				];
			];
		];
		If[histPrint,
			Print["New point"->newpt]
		]
    ];
    sol = Thread[vars->newpt];
    fstar = f/.sol;
    If[prSetup,
    	If[Converged, 
			PrintLabelledList[{{sol},iter-1},
			{"Optimum point","Iterations performed"},1],
			PrintLabelledList[{{sol},iter-1},
			{"NonOptimum point","Iterations performed"},1]
		]
	];
	{{fstar, sol, If[Converged, "Optimum", "NonOptimum"]}, history} 
]

nonZero[f_]:=If[N[f]==0.,True,False];
allZero[f_List]:=If[MemberQ[Map[nonZero,f],False],False,True];
dropAllZero[f_, df_]:=Module[{mf={}, mdf={}, i},
	Do[If[Not[allZero[df[[i]]]],
			AppendTo[mf,f[[i]]];
			AppendTo[mdf,df[[i]]]
		],
		{i,1,Length[f]}
	]; {mf, mdf}
];

SQPDirection[f_,g_,h_,df_,dg_,dh_,x_,pt_,
qpMethod_,maxQPIterations_, tol_, prResults_, qpDetails_]:=
Module[{vars,c,Q,gx,hx,dfx,dgx,dhx,rx,drx,lpg={},lph={},qpSoln,
n=Length[x],\[Lambda], qpStatus, A, b, xk={}, uk={}, H, qpTol = 0.0001},
    {gx,hx,dfx,dgx,dhx} = {g,h,df,dg,dh}/.ToRules[x==pt];
    If[prResults,
    	PrintLabelledList[{dfx,dgx,dhx},{"Gradients: \[Del]f", "\[Del]g", "\[Del]h"},1];
	    vars = Table[mySubscript["d",i], {i, 1, n}];
		Print["-------QP subproblem for direction-------"];
		Print["Minimize ",dfx.vars+1/2 vars.vars];
		If[g!={},lpg=Map[#\[LessEqual]0&,dgx.vars+gx]];
		If[h!={},lph=Map[#==0&,dhx.vars+hx]];
		If[Or[lpg!={},lph!={}],
			Print["Subject to "->MatrixForm[Join[lpg, lph]]]
		];
	];
    (* Remove constraints with zero gradients*)
    {gx, dgx} = dropAllZero[gx, dgx];
    {hx, dhx} = dropAllZero[hx, dhx];
	Switch[qpMethod,
		"ActiveSet", qpSoln = ActiveSetQPSolver[IdentityMatrix[n],dfx,
			dhx,-hx,dgx,-gx,maxQPIterations,qpTol, qpDetails];
			{qpSoln, qpStatus} = qpSoln[[{1,2}]];
			{xk, uk} = {qpSoln[[1]],Flatten[Drop[qpSoln,1]]},
		"PrimalDual",
			If[Length[gx]>0,
				al=AppendRows[dgx,-dgx,IdentityMatrix[Length[gx]]]
			];
			If[Length[hx]>0,
				If[Length[gx]!=0,
					ae=AppendRows[dhx,-dhx,
						ZeroMatrix[Length[hx],Length[gx]]],
					ae=AppendRows[dhx,-dhx]
				]
			];
			{A, b} = {Join[al,ae],-Join[gx,hx]};
			Do[If[b[[i]]<0, A[[i]]=-A[[i]];b[[i]]=-b[[i]]],
				{i,1,Length[b]}
			];
			c = Flatten[{dfx, -dfx, Table[0,{Length[gx]}]}];
			Q = Table[0,{2*n+Length[gx]},{2*n+Length[gx]}];
			H = IdentityMatrix[n];
			Q[[Range[2n],Range[2n]]]+=BlockMatrix[{{H,-H},{-H,H}}]; 
			(*PrintLabelledList[{c, Q, A,b},
			{"c","Q","A","b"},1];*)
			qpSoln = PrimalDualQPSolver[0, c, Q, A,b,{},
				maxQPIterations, 0.99, qpTol, qpDetails];
			xk = Apply[Subtract,{Take[qpSoln[[1]],n],
						Take[qpSoln[[1]],{n+1,2n}]}];
			uk = qpSoln[[3]];
			qpStatus = qpSoln[[4]],
		"ActiveSetDual",
			rx = Join[gx,hx]; drx=Join[dgx,dhx];
			c = drx.dfx - rx;
			Q = drx . Transpose[drx];
			vars = Join[Table[mySubscript["u",i], {i, 1, Length[g]}],
			    Table[mySubscript["v",i], {i, 1, Length[h]}]];
			If[prResults,
				Print["-------Dual QP subproblem-------"];
				Print["Minimize ",c.vars+1/2 vars.Q.vars]
			];
			qpSoln = ActiveSetDualQPSolver[0, c, Q, 
				Length[g], maxQPIterations, qpTol, "PolakRibiere",
				{}, vars, qpDetails];
			{\[Lambda], qpStatus} = qpSoln[[{1,2}]];
			{xk, uk}={-dfx-Transpose[drx].\[Lambda], \[Lambda]}
	];
	{{xk, uk}, qpStatus}
]

SQPApproxLineSearch[vars_, f_, g_List, h_List, pt_, d_, \[Mu]_, phi0_, gamma_,maxIter_,prResults_, stepDetails_] :=
Module[{j=0, alpha=1, d2,newPt, fcn, phiChange},
	d2 = d . d;
	newPt = pt + d;
	fcn = N[{f,g,h} /.ToRules[vars==newPt]];
	phi = meritFunction[fcn,\[Mu]];
	phiChange = phi + alpha gamma d2;
    If[stepDetails,
		Print["-------- Step length calculations --------"];
		PrintLabelledList[{\[Mu],d2,phi0,gamma},
			{"\[Mu]",Power["\[DoubleVerticalBar]d\[DoubleVerticalBar]",2],mySubscript["\[Phi]",0],"\[Gamma]"},2];
		PrintLabelledList[
			{alpha, {newPt}, MatrixForm[fcn]},
			{"----- Try \[Alpha]", "Point", 
			"Function values"MatrixForm[{"f","g","h"}]},1];
		PrintLabelledList[
				{phi, phiChange, If[phiChange\[GreaterEqual]phi0,"Fails","Passes"]},
			{"\[Phi]", "\[Phi]+\[Alpha]\[Gamma]"Superscript["d",2],"\[Phi] Test"},3]
	];
	While [And[phiChange >= phi0,j\[LessEqual]maxIter],
		alpha = (0.5)^(++j);
		newPt = pt + alpha d;
		fcn = N[{f,g,h} /.ToRules[vars==newPt]];
	   	phi = meritFunction[fcn,\[Mu]];
   		phiChange = phi + alpha gamma d2;
    	If[stepDetails,
			PrintLabelledList[
			{alpha, {newPt}, MatrixForm[fcn]},
			{"----- Try \[Alpha]", "Point", 
			"Function values"MatrixForm[{"f","g","h"}]},1];
			PrintLabelledList[
				{phi, phiChange, If[phiChange\[GreaterEqual]phi0,"Fails","Passes"]},
			{"\[Phi]", "\[Phi]+\[Alpha]\[Gamma]"Superscript["d",2],"\[Phi] Test"},3]
		];
	];
	If[phiChange >= phi0,Message[Step::"NoConvergence",alpha]; Abort[]];
    If[prResults,
		PrintLabelledList[{alpha},{"Step length"}]
	];
	newPt
]

meritFunction[{fx_, gx_, hx_}, \[Mu]_] := fx + \[Mu] Max[0, Abs[hx], gx];




RSQP[fs_, con_List, vars_, pt_, opts___?OptionQ] :=
Module[{ newpt, currentPt = N[pt], qpSoln={}, \[Delta], eps, maxIter, qpvars,iter=0, 
	history={{"Point","d","||d||","\[Phi]"}},fLabel="f",
	gLabels={},hLabels={}, g={}, h={}, prSetup, fstar, sol,
	df,dg={},dh={},dfLabel="\[Del]f",dgLabels={}, dhLabels={},
	Converged=False,dNorm,prResults,maxLineIter, d, w,\[Lambda],
	fcnVals, qpMethod, type, f, H, \[Phi], \[Gamma], lineMethod, 
	resetCounter=1,dLold, dLnew,resetH, rVal,
	maxQpIter,histPrint, qpPrint, qpDetails, stepPrint, stepDetails,
	gradient, dfx={}, dgx={}, dhx={}},
	{type, prResults, gradient, maxIter, eps, \[Delta], \[Gamma], lineMethod,
		maxLineIter,qpMethod, maxQpIter, resetH, rVal} = {ProblemType,
		PrintLevel, Gradient, MaxIterations,
		ConvergenceTolerance, LineSearchDelta, LineSearchGamma,
		StepLengthUsing,
		MaxLineSearchIterations,SolveQPUsing,MaxQPIterations,
		ResetQPHessian, QPConstraintFactor}/.
			Flatten[{opts,Options[RSQP]}];
	qpMethod = ToString[qpMethod];
	If[resetH==="Never", resetH=maxIter+1];
	Switch[prResults,
		0, {prSetup, histPrint, qpPrint, qpDetails, 
			stepPrint, stepDetails} = 
			{False, False, False, False, False, False},
		1, {prSetup, histPrint, qpPrint, qpDetails, 
			stepPrint, stepDetails} = 
			{True, False, False, False, False, False},
		2, {prSetup, histPrint, qpPrint, qpDetails, 
			stepPrint, stepDetails} = 
			{True, True, False, False, True, False},
		3, {prSetup, histPrint, qpPrint, qpDetails, 
			stepPrint, stepDetails} = 
			{True, True, True, False, True, False},
		4, {prSetup, histPrint, qpPrint, qpDetails, 
			stepPrint, stepDetails} = 
			{True, True, True, False, True, True},
		_, {prSetup, histPrint, qpPrint, qpDetails, 
			stepPrint, stepDetails} = 
			{True, True, True, True, True, True}
	];
	If[type===Max,f=-fs,f=fs];
	Switch[ToString[gradient],
		"Automatic", df=Grad[f,vars],
		"Numerical", df="Numerical",
		_, df=gradient[[1]]
	];
	{g,h} = StandardConstraints[con];
	If[g!={},
		gLabels = Table[mySubscript["g",i],{i,1,Length[g]}];
		dgLabels=Map["\[Del]"#&,gLabels];
		Switch[ToString[gradient],
			"Automatic", dg=Grad[g,vars],
			"Numerical", dg=Table["Numerical",{Length[g]}],
			_, dg=Take[Drop[gradient,1],Length[g]]
		];
	];
	If[h!={},
		hLabels = Table[mySubscript["h",i],{i,1,Length[h]}];
		dhLabels=Map["\[Del]"#&,hLabels];
		Switch[ToString[gradient],
			"Automatic", dh=Grad[h,vars],
			"Numerical", dh=Table["Numerical",{Length[h]}],
			_, dh=Take[Drop[gradient,1+Length[g]],Length[h]]
		];
	];
	If[prSetup,
		PrintLabelledList[{f,{df}},{"Minimize "<>fLabel,dfLabel},1];
		If[g!={},
			PrintLabelledList[{Thread[g\[LessEqual]0],dg},
			{"LE Constraints: "MatrixForm[gLabels],MatrixForm[dgLabels]},1]
		];
		If[h!={},
			PrintLabelledList[{Thread[h==0],dh},
			{"EQ Constraints: "MatrixForm[hLabels],MatrixForm[dhLabels]},1]
		]
	];
	H = IdentityMatrix[Length[vars]];
	While [And[++iter <= maxIter,Not[Converged]],
		fcnVals = {f,g,h} /.ToRules[vars==currentPt];		   
		If[histPrint,
			StylePrint["------------------ RSQP Iteration "<>
			ToString[iter]<>
			" ------------------","Output",FontWeight->"Bold"];
			PrintLabelledList[{{currentPt}, MatrixForm[fcnVals]},
			{"Current point", "Function values"MatrixForm[{"f","g","h"}]},1]
		];
		{d,w} =RSQPDirection[f,g,h,df,dg,dh,vars,currentPt,H,
			qpMethod, rVal, maxQpIter, eps, qpPrint, qpDetails];
		If[iter===1,
			\[Lambda] = Abs[w]; 
		    {dfx,dgx,dhx} = getGradients[f, g, h, df, dg, dh, vars, currentPt];
			dLold = (dfx + w.Join[dgx, dhx])
		];
		dNorm=Norm[d];
		If[histPrint,
			PrintLabelledList[{{d},dNorm,{w}},
			{"Direction","\[DoubleVerticalBar]d\[DoubleVerticalBar]","Lagrange multipliers"},2]
		];
		\[Phi] = RSQPmeritFunction[fcnVals, \[Lambda]]; 
		AppendTo[history, {currentPt,d,dNorm,\[Phi]}];
		If[dNorm\[LessEqual]eps,Converged=True; newpt=currentPt,
			{newpt, \[Lambda]} = RSQPLineSearch[vars, f, g, h, currentPt,
					 d, \[Lambda], w, \[Delta], \[Gamma], maxLineIter,
					 lineMethod, stepPrint, stepDetails];
			(*Update the Hessian*)
		    {dfx,dgx,dhx} = getGradients[f, g, h, df, dg, dh, vars, newpt];
			dLnew = (dfx + w.Join[dgx, dhx]);
			(*PrintLabelledList[{H,dLnew,w},{"H","dLnew","w"}];*)
			If[resetCounter<resetH,
				resetCounter = resetCounter + 1;
				H = updateHessian[currentPt, newpt, dLold, dLnew,H,qpPrint],
				H = IdentityMatrix[Length[vars]];
				resetCounter = 1		
			];
			dLold = dLnew;
			If[qpPrint,PrintLabelledList[{H},{"H"},1]];
		];
		If[histPrint,
			Print["New point"->newpt]
		];
		currentPt = newpt;
     ];
    sol = Thread[vars->newpt];
	fcnVals = {f,g,h} /.sol;
	If[prSetup,   
		If[Converged, 
			PrintLabelledList[{{sol},MatrixForm[fcnVals],iter-1},
			{"Optimum point","Function values","Iterations performed"},1],
			PrintLabelledList[{{sol},MatrixForm[fcnVals],iter-1},
			{"NonOptimum point","Function values","Iterations performed"},1]
		]
	];
	{{fcnVals[[1]],sol, If[Converged, "Optimum", "NonOptimum"]}, history} 
]

getGradient[{f_List, df_List}, vars_, pt_]:=
	MapThread[getGradient[{#1, #2},vars,pt]&,{f,df}];

getGradient[{f_, df_}, vars_, pt_]:=
	If[df==="Numerical", Grad[f,vars,pt], df/.Thread[vars->pt]];
	
getGradients[f_, g_, h_, df_, dg_, dh_, vars_, pt_]:=
	Map[getGradient[#,vars,pt]&,{{f,df},{g,dg},{h,dh}}]
	
updateHessian[x1_, x2_, dL1_, dL2_, H_, prResults_] := 
Module[{s, dLnew,q, Hnew, Hs, qs, qqT, HssH, sHs,
	\[Theta], \[Gamma], ss},
	s = x2 - x1;
	q = dL2 - dL1;
	qs = q.s;
	If [qs \[LessEqual] 0, Hnew=H,
		Hs = H.s;
		sHs = s. Hs;
		If [qs \[GreaterEqual] 0.2 sHs,
			\[Theta] = 1,
			\[Theta] = 0.8 sHs/(sHs - qs)
		];
		\[Gamma] = \[Theta] q + (1-\[Theta]) Hs;
		qqT = Outer[Times,\[Gamma],\[Gamma]];
		HssH = Outer[Times,Hs,Hs];
		Hnew = H + qqT/qs - HssH/sHs; 
		If[prResults,
			Print["Updating Hessian"];
			PrintLabelledList[{s, q, Hs, qs, sHs, \[Theta], \[Gamma]},
					{"s", "q","H.s","qT.s","s.H.sT", "\[Theta]", "\[Gamma]"},2];
			PrintLabelledList[{qqT, HssH},
				{"\[Gamma].\[Gamma]T","H.s.sT.H"},1]
		]
	];
	Hnew
];

nonZero[f_]:=If[N[f]==0.,True,False];
allZero[f_List]:=If[MemberQ[Map[nonZero,f],False],False,True];
dropAllZero[f_, df_]:=Module[{mf={}, mdf={}, i},
	Do[If[Not[allZero[df[[i]]]],
			AppendTo[mf,f[[i]]];
			AppendTo[mdf,df[[i]]]
		],
		{i,1,Length[f]}
	]; {mf, mdf}
];

RSQPDirection[f_,g_,h_,df_,dg_,dh_,x_,pt_,H_,
qpMethod_, r_, maxQPIterations_, tol_, prResults_, qpDetails_]:=
Module[{vars,A, b, c,Q,gx,hx,rx,drx,lpg={},lph={},qpSoln,
n=Length[x],\[Lambda], qpStatus, xk, uk, HI, al={}, ae={}, qpTol=0.0001,dfx={},dgx={},dhx={}},
    {gx,hx} = {g,h}/.ToRules[x==pt];
    gx = Map[If[#\[LessEqual]0,#,r#]&,gx];
    hx = r * hx;
	{dfx,dgx,dhx} = getGradients[f, g, h, df, dg, dh, x, pt];
    If[prResults,
    	PrintLabelledList[{dfx,dgx,dhx},{"Gradients: \[Del]f", "\[Del]g", "\[Del]h"},1];
	    vars = Table[mySubscript["d",i], {i, 1, n}];
		Print["-------QP subproblem for direction-------"];
		Print["Minimize ",dfx.vars+1/2 vars.H.vars];
		If[g!={},lpg=Map[#\[LessEqual]0&,dgx.vars+gx]];
		If[h!={},lph=Map[#==0&,dhx.vars+hx]];
		If[Or[lpg!={},lph!={}],
			Print["Subject to "->MatrixForm[Join[lpg, lph]]]
		];
	];
    (* Remove constraints with zero gradients*)
    {gx, dgx} = dropAllZero[gx, dgx];
    {hx, dhx} = dropAllZero[hx, dhx];
	Switch[qpMethod,
		"ActiveSet", qpSoln = ActiveSetQPSolver[H,dfx,
			dhx,-hx,dgx,-gx,maxQPIterations,qpTol, qpDetails];
			{qpSoln, qpStatus} = qpSoln[[{1,2}]];
			{xk, uk} = {qpSoln[[1]],Flatten[Drop[qpSoln,1]]},
		"PrimalDual",
			If[Length[gx]>0,
				al=AppendRows[dgx,-dgx,IdentityMatrix[Length[gx]]]
			];
			If[Length[hx]>0,
				If[Length[gx]!=0,
					ae=AppendRows[dhx,-dhx,
						ZeroMatrix[Length[hx],Length[gx]]],
					ae=AppendRows[dhx,-dhx]
				]
			];
			{A, b} = {Join[al,ae],-Join[gx,hx]};
			Do[If[b[[i]]<0, A[[i]]=-A[[i]];b[[i]]=-b[[i]]],
				{i,1,Length[b]}
			];
			c = Flatten[{dfx, -dfx, Table[0,{Length[gx]}]}];
			Q = Table[0,{(2*n)+Length[gx]},{(2*n)+Length[gx]}];
			Q[[Range[2*n],Range[2*n]]]+=BlockMatrix[{{H,-H},{-H,H}}]; 
			(*PrintLabelledList[{c, Q, A,b},
			{"c","Q","A","b"},1]*);
			qpSoln = PrimalDualQPSolver[0, c, Q, A,b,{},
				maxQPIterations, 0.99, qpTol, qpDetails];
				xk = Apply[Subtract,{Take[qpSoln[[1]],n],
						Take[qpSoln[[1]],{n+1,2n}]}];
				uk = qpSoln[[3]];
				Do[uk[[i]]=Abs[uk[[i]]],{i,1,Length[gx]}];
				qpStatus = qpSoln[[4]],
		"ActiveSetDual",
			rx = Join[gx,hx]; drx=Join[dgx,dhx];
			HI = Inverse[H];
			c = drx.HI.dfx - rx;
			Q = drx . HI. Transpose[drx];
			vars = Join[Table[mySubscript["u",i], {i, 1, Length[g]}],
			    Table[mySubscript["v",i], {i, 1, Length[h]}]];
			If[prResults,
				Print["-------Dual QP subproblem-------"];
				Print["Minimize ",c.vars+1/2 vars.Q.vars]
			];
			qpSoln = ActiveSetDualQPSolver[0, c, Q, 
			Length[g], maxQPIterations, 
				qpTol, PolakRibiere, {}, vars, qpDetails];
			{uk, qpStatus} = qpSoln[[{1,2}]];
			xk =HI.(-dfx-Transpose[drx].uk)
	];
	If[qpStatus!="Optimum",
		PrintLabelledList[{qpStatus,pt},{"QP failed: status","at point"}];
		Abort[]
	];
	{xk, uk}
]


RSQPLineSearch[vars_, f_, g_List, h_List, pt_, d_, \[Lambda]p_, w_, 
\[Delta]_, \[Gamma]_, maxIter_, lineMethod_, prResults_, stepDetails_] :=
Module[{\[Lambda], \[Phi], alpha = "\[Alpha]", pta, step, interval, tol = 0.01, done=False,
fx, gx, hx},
	pta = pt + alpha d;
	\[Lambda] = Map[Max[#]&,Transpose[{(\[Lambda]p+Abs[w])/2,Abs[w]}]];
	(*{fx, gx, hx} = {f,g,h}/.Thread[vars->(pt + alpha d/Norm[d])];*)
	{fx, gx, hx} = {f,g,h}/.Thread[vars->pta];
	\[Phi] = RSQPmeritFunction[{fx, gx, hx},\[Lambda]];
	If[stepDetails, PrintLabelledList[{\[Phi]},{"\[Phi]"},1]];
	Switch[ToString[lineMethod],
		"QuadraticSearch", step = QuadraticSearch[\[Phi],alpha,\[Delta], maxIter,
				tol,stepDetails],
		"GoldenSectionSearch", step = GoldenSectionSearch[\[Phi],
			 alpha,{0,.1}, 0.001, stepDetails], 
		_, step = RSQPApproxLineSearch[\[Phi], d, alpha, \[Gamma], 
				maxIter, stepDetails]
	];
	If[step<10^(-6), Message[Step::"TooSmall",step];Abort[]];
	If[prResults, PrintLabelledList[{step,{\[Lambda]}},{"Step length","\[Lambda]"},1]];
	{pta/.alpha->step, \[Lambda]}
]

RSQPmeritFunction[{fx_, gx_, hx_}, \[Lambda]_] := fx + 
	\[Lambda] .(Flatten[{Map[Max[0,#]&,gx],Abs[hx]}]);

RSQPApproxLineSearch[\[Phi]_, d_, \[Alpha]_, gamma_, maxIter_, stepDetails_] :=
Module[{j=0, alpha=1, d2, phi0, phi, phiChange, notDone=True},
	d2 = d . d;
	phi0 = \[Phi]/.\[Alpha]->0; 
    If[stepDetails,
		PrintLabelledList[{phi0},{mySubscript["\[Phi]",0]}]
	];
	While [And[notDone,j\[LessEqual]maxIter],
	   	phi = \[Phi]/.\[Alpha]->alpha;
   		phiChange = phi + alpha gamma d2;
    	If[stepDetails,
			PrintLabelledList[
			{alpha},{"----- Try \[Alpha]"},1];
			PrintLabelledList[
				{phi, phiChange, If[phiChange\[GreaterEqual]phi0,"Fails","Passes"]},
			{"\[Phi]", "\[Phi]+\[Alpha]\[Gamma]"Superscript["d",2],"\[Phi] Test"},3]
		];
   		If[phiChange<phi0,notDone=False,alpha = (0.5)^(++j)]
	];
	If[notDone,Message[Step::"NoConvergence",alpha]; Abort[], alpha]
]



End[];

EndPackage[]