(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)









BeginPackage["OptimizationToolbox`EconomicFactors`"];

spcaf::usage = "spcaf[i, n] - returns single payment compound amount factor, (1 + i)^n";

sppwf::usage = "sppwf[i, n] - returns single payment present worth factor, 1/spcaf[i, n].";

uscaf::usage = "uscaf[i, n] - returns uniform series compound amount factor, ((1 + i)^n - 1)/i.";

sfdf::usage = "sfdf[i, n] - returns sinking fund deposit factor, 1/uscaf[i,n].";

uspwf::usage = "uspwf[i, n] - returns uniform series present worth factor, (1 - (1 + i)^(-n))/i.";

crf::usage = "crf[i, n] - returns capital recovery factor, 1/uspwf[i,n].";

CashFlowDiagram::usage="CashFlowDiagram[data, opts]. Draws a cash flow diagram. The data is expected in a two dimensional list. Each sublist consists of either 2 or 3 entries. The 2 entries are interpreted as {value, period}. The three entries are assumed as a uniform series {value, startPeriod, endPeriod}. The value may be either a numerical value or in the form of 'label'->value. The numerical value or the label, if specified, is placed on the diagram. The opts may be any valid option for the graphics Show function.";

Options[CashFlowDiagram] = 
	{LabelPlacementOffsets->{0.15,{-.1,-.1}}
};



Begin["`Private`"];
Needs["Utilities`FilterOptions`"];



spcaf[i_, n_] := (1 + i)^n;
sppwf[i_, n_] := 1/spcaf[i, n];
uscaf[i_, n_] := ((1 + i)^n - 1)/i;
sfdf[i_,n_] := 1/uscaf[i,n];
uspwf[i_, n_] := (1 - (1 + i)^(-n))/i;
crf[i_,n_] := 1/uspwf[i,n];

generateVals[{c_,start_,end_}]:=Table[{k,c},{k,start,end}];
generateVals[{c_,i_}]:={{i,c}};

CashFlowDiagram[a_List,opts___Rule]:=
Module[{n=Length[a], vals, labels, data={}, gdata={}, tdata={}, gap, 
offset, vs},
    offset = LabelPlacementOffsets /. 
		Flatten[{opts}] /. Options[CashFlowDiagram];
	vals = Map[If[NumberQ[#[[1]]],#,Join[{Last[#[[1]]]},Rest[#]]]&,a];
	vs = Map[First,vals];
	vs = Max[vs]-Min[vs];
	gap = 1 + offset[[1]];
	offset = Flatten[{Rest[offset]}];
	offset = {offset[[1]], offset[[2]]*vs/2};
	labels = Map[If[NumberQ[#[[1]]],#,Join[{First[#[[1]]]},Rest[#]]]&,a];
	data = Sort[Flatten[Map[generateVals,vals],1]];
	gdata = Join[{RGBColor[0,0,1]},Map[Line[{{#[[1]],0},#}]&,data],
		{RGBColor[1,0,0]},{Line[{{data[[1,1]],0},{Last[data][[1]],0}}]}];
	tdata = Join[Table[Text[labels[[i,1]],
		{vals[[i,2]], gap*vals[[i,1]]}],{i,1,n}],
		Table[Text[a[[i,2]],{vals[[i,2]],0}+offset],{i,1,n}],
		{Text[Last[data][[1]],{Last[data][[1]],0}+offset]}];
	Show[Graphics[{gdata,tdata}],Evaluate[FilterOptions[Graphics,opts]],
	TextStyle->{FontFamily->"Times",FontSize->10}];
];



End[];

EndPackage[]