(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)









BeginPackage["OptimizationToolbox`GraphicalSolution`",
"OptimizationToolbox`CommonFunctions`"];

GraphicalSolution::usage ="GraphicalSolution[f,{x,xmin,xmax}, {y,ymin,ymax}, options]. The function draws contours of the objective function (f) and optionally those for constraint functions. All contours are labelled. The function returns a graphics object. See Options[GraphicalSolution] for a description of different options for this function.";

Options[GraphicalSolution] = 
	{ObjectiveContours->5,
	ObjectiveContourLabels->True,
	Constraints->{}, 
	ConstraintLabels->{},
	ShadingOffset->0.1, 
	ShadingThickness->0.015, 
	EQConstraintThickness->0.01,
	PrintPoints->False,
	GradientVectors->{},
	GradientVectorScale->0.25,
	PlotHistory->{}
};

ObjectiveContours::usage = "ObjectiveContours: Number of objective function contours to be drawn or a list of specific values for which the contours are desired. Default is ObjectiveContours->5.";

ObjectiveContourLabels::usage="ObjectiveContourLabels: Option for GraphicalSolution to put labels on the objective function contours. Default is ObjectiveContourLabels->True.";

Constraints::usage="Constraints: List of constraint expressions. A constraint can be specified as a simple expression, in which case it is assumed as a '\[LessEqual]' constraint with a zero righthand side. A constraint can also be specified as as lefthand side '< , \[LessEqual] (both assumed as \[LessEqual])', '>, \[GreaterEqual] (both assumed as \[GreaterEqual])', or '==' righthand side. Such constraints are first converted to standard form ('\[LessEqual]' or '==' with righthand side zero). Because of these rearrangements, the order of the constraints may be different than that used in the input list of constraints. Default is Constraints->{}.";

ConstraintLabels::usage="ConstraintLabels: List of labels to be used to identify the constraints on the graph. Default is gi for LE constraints and hi for EQ constraints.";

ShadingOffset::usage = "ShadingOffset: This factor is used to determine the offset for shading to show the infeasible side for inequalities. Default is ShadingOffset->0.1.";

ShadingThickness::usage = "ShadingThickness: defines the thickness of shading to show the infeasible side for inequalities. Default is ShadingThickness->0.015.";

EQConstraintThickness::usage = "EQConstraintThickness: defines the thickness of line to show the equality constraint. Default is EQConstraintThickness->0.01.";

PrintPoints::usage = "PrintPoints: Option for GraphicalSolution to print values of few data points used to draw each contour. Default is PrintPoints->False.";

GradientVectors::usage="GradientVectors->{{f1,\[Ellipsis]},{f1_Label,\[Ellipsis]},{{x1,y1},\[Ellipsis]}}. Draw gradient vectors at given points. A list of functions, labels, and points where vectors are drawn is expected. By default, no gradient vectors are drawn.";

GradientVectorScale::usage= "GradientVectorScale: Scale factor by which the gradient vectors are multiplied before plotting. Default is GradientVectorScale->0.25.";

PlotHistory::usage="PlotHistory->{{x1,y1},\[Ellipsis]}. Shows a joined list of points on the plot. One use is to show the history of the search in numerical methods.";



Begin["`Private`"];

Needs["Utilities`FilterOptions`"];
Needs["OptimizationToolbox`LabelContour`"];
Needs["Graphics`Arrow`"];
Off[ContourPlot::plnr];
Off[ContourGraphics::ctpnt];



GraphicalSolution[f_,x_List,y_List,opts___?OptionQ]:=
Module[{g={},h={},gLabels={},hLabels={},fvals,cons, consLabels,
	origVars, newvars, xx, yy},
    {cons, consLabels} = {Constraints, ConstraintLabels} /. 
		Flatten[{opts}] /. Options[GraphicalSolution];
    cons = Flatten[{cons}];
    consLabels = Flatten[{consLabels}];
	If[Length[cons]\[GreaterEqual]1,{g,h}=StandardConstraints[cons]];
	If[consLabels==={},
		If[Length[g]\[LessEqual]1,gLabels={"g"},
			gLabels = Table[mySubscript["g",i],{i,1,Length[g]}]
		];
		If[Length[h]\[LessEqual]1,hLabels={"h"},
			hLabels = Table[mySubscript["h",i],{i,1,Length[h]}]
		],
		gLabels = consLabels[[Range[Length[g]]]];
		hLabels = Drop[consLabels,Length[g]]		
	];
	(*PrintLabelledList[{f},{"Objective function"}];
	If[Length[g]\[GreaterEqual]1,PrintLabelledList[{Thread[gLabels->Thread[g\[LessEqual]0]]},
		{"LE Constraints"},1]
	]; 
	If[Length[h]\[GreaterEqual]1,PrintLabelledList[{Thread[hLabels->Thread[h==0]]},
		{"EQ Constraints"},1]
	];*) 
    fvals = ObjectiveContours /. {opts} /. Options[GraphicalSolution];
	If[fvals==={},fvals=5];
	If[VectorQ[fvals],fvals=Sort[fvals]];
	
	(* To avoid problem with possible subscripted variables, change
	all problem variables to internal variables*)
	origVars = {x[[1]],y[[1]]};
	newvars = Thread[origVars->{xx,yy}];
	graphicalSoln[x/.newvars,y/.newvars,{{f/.newvars,fvals},
		{g/.newvars,gLabels},{h/.newvars,hLabels}},origVars,opts]
]

graphicalSoln[xRange_List, yRange_List,{f_, g_, h_}, origVars_, opts___] :=
Module[{a={}, b={}, c={}, d={}, e={}, ff={},vecs={}, grd, scale,
	pltHist, printPoints, xhist={}},
	{a, b} = ObjectivePlot [f, xRange, yRange, opts];
	If [g[[1]] != {},
		{c, d} = LEConstraintPlot [g, xRange, yRange, opts]
	];
	If [h[[1]] != {},
		{e, ff} = EQConstraintPlot [h, xRange, yRange, opts]
	];
	{grd, scale, pltHist, printPoints}=
	{GradientVectors, GradientVectorScale, PlotHistory, PrintPoints} /. 
       		 {opts} /. Options[GraphicalSolution];
	If [grd!={},
		vecs=DrawGradients [grd,origVars, scale];
	];
	If[pltHist!={},
		xhist = ListPlot[pltHist,
				Evaluate[FilterOptions[ListPlot,opts]],
				PlotStyle->{Dashing[{0.05, 0.05}]},
				PlotJoined->True,AspectRatio->1,
				PlotRange->{xRange[[{2,3}]],yRange[[{2,3}]]},
				DisplayFunction -> Identity]
	];
	If [printPoints,PrintLabelledList[
		{TableForm[b], TableForm[d], TableForm[ff]},
		{"Objective","LE Constraints","EQ Constraints"},1]];
	Show[{xhist,a,c,e,vecs}, 
		Evaluate[FilterOptions[Graphics,opts]],
		Axes->True, AxesLabel->origVars,
		TextStyle->{FontFamily->"Times",FontSize->10},
		DisplayFunction -> $DisplayFunction]
]

LEConstraintPlot::usage = "LEConstraintPlot [{fcns, labels},{x,xmin,xmax}, {y,ymin,ymax}, opts]. It returns graphics objects	containing contours for the constraint functions (fcns). Specified labels are placed at one end of each constraint contour. Two contours are drawn for each constraint. One is for contour value equal to 0 and	the other is for a slightly violated constraint to show the	infeasible side. Each contour is drawn using specified number of points. Offset is used to determine the text offset and second contour showing infeasible side.";

LEConstraintPlot [{fcns_, labels_},{x_,xmin_,xmax_}, {y_,ymin_,ymax_},opts___] := 
Module[{dx, dy, offset, b, c, d, e={}, f={},
	n = Length[fcns], label, fcn, sc, shadeThick},
	{shadeThick, offset} = {ShadingThickness, 
		ShadingOffset}/.{opts}/.Options[GraphicalSolution];
	dx=(xmax - xmin)/10; dy=(ymax - ymin)/10;
	Do[ fcn = fcns[[i]]; label = labels[[i]];
		(*Draw contour for zero value*)
		b = Graphics[ContourPlot[fcn,
			{x,xmin,xmax}, {y,ymin,ymax},
			Evaluate[FilterOptions[ContourPlot,opts]],
			AspectRatio->1, DisplayFunction -> Identity,
			ContourShading->False,Contours->{0}, 
			ContourStyle->{{GrayLevel[0]}}]];
		AppendTo[e, b];
		(* get the last point to put the label*)
		c = Cases[Flatten[b[[1]]],_Line];
		If [c != {},
			d = c[[1,1,-2]];
			(*Set scale for slightly violated contour*)
			sc = Max[offset,Abs[N[fcn /. ToRules[{x,y}==d+offset{dx,dy}]]]];
			b = Graphics[ContourPlot[fcn,{x,xmin,xmax},
				{y,ymin,ymax},
				Evaluate[FilterOptions[ContourPlot,opts]],
				AspectRatio->1, DisplayFunction -> Identity,
				ContourShading->False,Contours->{sc},
				ContourStyle->{{RGBColor[0,1,0],Thickness[shadeThick]}}]];
			PrependTo[e, b];
			AppendTo[e,Graphics[Text[label,Offset[{4,4},d]]]];
			AppendTo[f, {label -> N[fcn /. ToRules[{x,y} == d]],
						SelectPoints[c[[1,1]]]}]
		],{i, 1, n}
	]; {e, f}
]

SelectPoints[a_]:=a[[Divisors[Length[a]]]]	


EQConstraintPlot::usage = "EQConstraintPlot [{fcns, labels}, {x,xmin,xmax}, {y,ymin,ymax}, opts]. It returns graphics objects	containing contours for the constraint functions (fcns). Specified labels are placed at one end of each constraint contour. Each contour is drawn using specified number of points. Offset is used to determine the text offset.";

EQConstraintPlot [{fcns_, labels_},{x_,xmin_,xmax_}, {y_,ymin_,ymax_},opts___] := 
Module[{b, c, d, e={}, f={},n = Length[fcns], label, fcn,thick},  
	thick = EQConstraintThickness/.Flatten[{opts}]/.
		Options[GraphicalSolution];
	Do[ fcn = fcns[[i]]; label = labels[[i]];
		(*Draw contour for zero value*)
		b = Graphics[ContourPlot[fcn,
			{x,xmin,xmax}, {y,ymin,ymax},
			Evaluate[FilterOptions[ContourPlot,opts]],
			AspectRatio->1, DisplayFunction -> Identity,
			ContourShading->False,Contours->{0}, 
			ContourStyle->{{Thickness[thick]}}]];
		AppendTo[e, b];
		(* get the last point to put the label*)
		c = Cases[Flatten[b[[1]]],_Line];
		If [c != {},d = c[[1,1,-2]];
			AppendTo[e,Graphics[Text[label,Offset[{4,4},d]]]];
			AppendTo[f,{label -> N[fcn /. ToRules[{x,y} == d]],
				SelectPoints[c[[1,1]]]}]
		],{i, 1, n}
	]; {e, f}
]

ObjectivePlot::usage = "ObjectivePlot [{fcn, contourValues}, {x,xmin,xmax}, {y,ymin,ymax}, opts]. It returns graphics objects	containing contours for the objective function (fcn). List of contourValues must be given. Each contour is drawn using specified number of points.";	

ObjectivePlot [{fcn_, contourValues_}, 
{x_,xmin_,xmax_}, {y_,ymin_,ymax_},opts___] :=
Module[{a, b, c, d, f = {},labels},
	labels = ObjectiveContourLabels/.Flatten[{opts}]/.
		Options[GraphicalSolution];
	a = ContourPlot[fcn, {x,xmin,xmax}, {y,ymin,ymax},
		Evaluate[FilterOptions[ContourPlot,opts]],
		AspectRatio->1, DisplayFunction -> Identity, 
		ContourShading->False, Contours-> contourValues,
		ContourStyle->{RGBColor[0,0,1]}];
	b = Graphics[a];
	c = Cases[Flatten[b[[1]]],_Line];
	If [c != {},
		Do[	d = c[[i]][[1,1]];
			AppendTo[f, {"f "-> N[fcn /. ToRules[{x,y}==d]], 
				SelectPoints[c[[i,1]]]}],{i,1,Min[5,Length[c]]}
		];
		If[labels, b = Graphics[LabelContourLines[a,
			Evaluate[FilterOptions[LabelContourLines,opts]],
			DisplayFunction -> Identity]]
		];
	];{b, f} 
]

DrawGradients[{f_,labels_, pts_},{x_,y_},scale_]:=
Module[{vecs},
	vecs=Flatten[Map[gradVecs[f[[#]],x,y,pts,labels[[#]],scale]&,
		Range[Length[f]]],1];
	Graphics[vecs]
];

gradVecs[f_,x_, y_,pts_,label_,scale_]:=
Module[{gradf,ptsRules,gradPts,vecs,endPts,pos},
	gradf=Grad[f, {x,y}];
	ptsRules=Map[ToRules[{x,y}==#]&,pts];
	gradPts=gradf/.ptsRules;
	endPts =Table[pts[[i]]+scale*gradPts[[i]],{i,1,Length[pts]}];
	pos=Table[If[endPts[[i,1]]\[LessEqual]pts[[i,1]],{1,0},{-1,0}],{i,1,Length[pts]}];
	vecs=Table[{Text[label,endPts[[i]],pos[[i]]],Arrow[pts[[i]],
		endPts[[i]],HeadScaling -> Relative]},{i,1,Length[pts]}];
	vecs
];



End[];

EndPackage[]