(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)









BeginPackage["OptimizationToolbox`LabelContour`", "Utilities`FilterOptions`"];

LabelContourLines::usage = 
	"LabelContourLines[ cont, opts] displays the contour plot
	 cont with a label on each contour line giving its height.";

LabelPlacement::usage =
	"LabelPlacement is an option of LabelContourLines that
	 determines how the labels are placed.  A value
	 of Center will use the mid-point of each contour line.
	 A value of Automatic will attempt to find labels that
	 are spaced away from each other.";

PointFactor::usage =
	"PointFactor is an option of LabelContourLines that is used
	 when the LabelPlacement is set to Automatic.  It takes a
	 positive number that determines the weighting function
	 that is used to find the points at which labels are placed.
	 A value of 1 means that the same weight is given in the x
	 and y directions.  A value of less than 1 spreads labels
	 in the x direction while a value of greater than 1 spreads
	 them out in the y direction.";

PointSkip::usage =
	"PointSkip is an option of LabelContourLines that is used
	 when the LabelPlacement is not set to be Automatic.  It
	 determines how many points are examined as candidates
	 for placing labels.   A setting of 4 will ensure that
	 every fourth point along each line is examined.";



Begin["`Private`"];





If[ Not[ $VersionNumber > 2.2],
	textFun[ Text[ t_, {x_, y_, ang_}], font_, form_] :=
		Text[ FontForm[ t, font], {x,y}, 1.6 {Sin[ang],Cos[ang]}],
	textFun[ Text[ t_, {x_, y_, ang_}], font_, form_] :=
		If[ PretendToBeOld === True,
			Text[ FontForm[ t, font], {x,y}, 1.6 {Sin[ang],Cos[ang]}],
			Text[ t, {x,y}, 
				(*DefaultFont -> font,*)
				FormatType -> form,
				Background -> None]
		]
	]

Options[ LabelContourLines] =
	{
	FormatType -> Automatic,
	LabelPlacement -> Center,
	PointFactor -> 1,
	PointSkip -> 4
	};

GetFont[ {name_String, size_}, def_] :=
	{ name, CheckSize[ size]}

GetFont[ name_String, def_] :=
	If[ Length[ def] === 2,
			{name, CheckSize[ Last[ def]]},
			{name, 6}]

GetFont[ size_, def_] :=
	If[ Length[ def] === 2,
			{First[ def], CheckSize[size]},
			{"Courier", CheckSize[ size]}]

CheckSize[ x_] := If[ Positive[ x], x, 6, 6]

CheckPlace[ x_] := Switch[ x, Center, Center, Automatic, Automatic, _, Center]

CheckFactor[ x_] := If[ NumberQ[x] && x > 0, x, 1]



LabelContourLines[ g:ContourGraphics[ data_, opts___], lopts___] :=
    Module[{conts, style, shade, factor, form,
    	   c, prims, opt, levs, text, font,
	   	   ostyle, place, skip, fact, max},

		opt = Join[ {lopts}, Options[ LabelContourLines]] ;
	    font = GetFont[ LabelFont /. opt, 
							LabelFont /. Options[ LabelContourLines]] ;
	    form = FormatType /. opt ;
		place = CheckPlace[ LabelPlacement /. opt] ;
		skip = PointSkip /. opt ;
		fact = CheckFactor[ PointFactor /. opt] ;
		opt = Join[ Flatten[{opts}], Options[ ContourGraphics]] ;
		ostyle = ContourStyle /. opt ;
		shade = ContourShading /. opt ;
		conts = Contours /. opt ;
		conts = FindContours[ conts, 
					Last[ FullOptions[ g, PlotRange]]] ;
    	max = Max[ Abs[ conts]] ;
		style = Table[ {AbsoluteThickness[ i]}, {i,Length[ conts]}] ;

		c = Show[ g,
			Contours -> conts,
			ContourStyle -> style, 
			DisplayFunction -> Identity] ;
		c = Graphics[ c] ;
		prims = First[ c] ;
		opt = List @@ Rest[ c] ;
		levs = If[ shade,
		    levs = Drop[ prims, 1] ;
	 	    Map[ (# /. 
		         {__, {___, AbsoluteThickness[ t_], ___, Line[ pts_]}} -> 
			 		{t, pts})&,
			  levs]
		(* else *) ,
	 	    Map[ (# /. 
		         {___, AbsoluteThickness[ t_], ___, Line[ pts_]} -> 
			 		{t, pts})&,
			  prims]] ;
		ostyle = FixStyle[ ostyle, Length[ conts]] ;
		prims = Map[ (# /. 
		    AbsoluteThickness[ t_] :> 
		    Sequence @@ Part[ ostyle, t])&, prims] ; 
		
		If[ place === Center,
				levs = Map[ { Part[conts, First[#]], Last[#]}&, levs] ;
				text = Map[ MidTextCalc[#,max]&, levs]
			
			, (* else *)

			levs = Map[ FixLevs[ #, skip]&, levs] ;
			text = Table[ TextCalc[ conts, levs, i, fact, max], 
										{i, Length[ levs]}]
			] ;

		text = Map[ textFun[#, font, form]&, text] ;
		
		opt = opt /. (DisplayFunction -> Identity) -> 
								Options[ Graphics, DisplayFunction] ;
		Show[ 
	    	Graphics[ {prims, text}, 
				Evaluate[FilterOptions[ Graphics, lopts], opt]]]
		]

	
MidTextCalc[ {cont_, line_}, max_] :=
	Text[ NumberFunction[ cont, max], GetLinePosition[ line]]

GetLinePosition[ line_] :=
	Module[{pos},
		If[ Length[ line] === 2,
			Append[ Apply[ Plus, line]/2, Apply[ AngCal, line]],
			pos = Ceiling[ Length[ line]/2.] ;
			Append[ Part[ line, pos], AngCal[ line[[pos-1]], line[[pos+1]]]]
			]
		]

	
AngCal[ p1_, p2_] :=
	N[ 2Pi - Apply[ ArcTan, p2-p1]]


FixLevs[ {num_, lev_}, fact_] :=
    Module[{len, nfact},
    	nfact = fact ;
    	len = Length[ lev] ;
	If[ len < nfact*4,
		nfact = Floor[ len/4]] ;
	If[ Head[ nfact] =!= Integer || nfact < 1,
		nfact = 1] ;
 	If[ len < 4,
		{num, lev},
		{num, Map[ First, Partition[ Take[ lev, {2, -2}], nfact]]}]
	]

	
FindMin[ pt_, test_, wght_] :=
	Min[ Map[ (tmp = (#-pt)*{1,wght}; tmp.tmp)&, test]]

	
FixDists[ inp_List] :=
    Module[{},
    	{coord, dists} = Transpose[ inp] ;
		If[ Not[True === SameQ @@ coord], Print[ "Mess Up in FixDists"]] ;
		{Part[ coord, 1], Times @@ dists}
	]

	
TextCalc[ vals_, levs_, num_, wght_, cmax_] :=
    Module[{test, cnum, dists, max, i, pos, cont, ang, rpos, lpos}, 
    	cont = Part[ levs, num] ;
		cnum = Part[ cont, 1] ;
		test = Select[ levs, (Abs[ Part[ #, 1]-cnum] === 1.)&] ;
		test = Map[ Part[ #, 2]&, test] ;
		cont = Part[ cont, 2] ;
		dists = 
	    	Map[ 
	        	Table[ 
		    	{
		    	i,
		    	FindMin[ Part[ cont, i], #, wght]
		    	}, {i, Length[ cont]}]&, test] ;
		dists = Transpose[ dists] ;
		dists = Map[ FixDists, dists] ;
		dists = dists * 
			Join[ {{1, 0.5}}, 
				Table[ {1, 1}, {Length[dists]-2}], {{1, 0.5}}] ;
		max = Part[ dists, 1] ;
		Do[ If[ Part[ max, 2] < Part[ dists, i, 2], max = Part[ dists,i]],
			{i, 2, Length[ dists]}] ;
		pos = Part[ max, 1] ;
		If[ Length[ cont] < 3,
			ang = Apply[ AngCal, cont],
			lpos = If[ pos == 1, 1, pos-1] ;
			rpos = If[ pos == Length[ cont], pos, pos+1] ;
			ang = AngCal[ cont[[lpos]], cont[[rpos]]]] ;
		pos = Append[ Part[ cont, pos], ang] ;
		Text[ NumberFunction[ Part[ vals, cnum], cmax], pos]
	];
	
FixStyle[ Automatic, num_] := FixStyle[ Thickness[ 0.001], num];

FixStyle[ style_, num_] := FixStyle[ {style}, num];

FixStyle[ style_List, num_] :=
	If[ ListQ[ style] && Length[ style] > 0 &&
	    ListQ[ First[ style]],
		Table[ First[ RotateLeft[ style, i-1]], {i,num}],
		Table[ style, {num}]];


FindContours[ x_List, {z1_, z2_}] := x

FindContours[ n_Integer /; n > 0, {z1_, z2_}] :=
    Module[{zinc},
	zinc = (z2 - z1)/ (n + 1) ;
	Table[ i, {i, z1 + zinc, z2 - zinc, zinc}]
	]


NumberFunction[ x_, max_] :=
    Module[{t, digs},
    	digs = Floor[ Log[ 10, max]] ;
	digs = N[ 10^digs] ;
	t = x/digs ;
	t = Floor[ t 100] ;
	t = t*digs/100 ;
	ToString[ NumberForm[ t, 3]]
	]



End[];

EndPackage[]























