(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)









BeginPackage["OptimizationToolbox`Unconstrained`",
"OptimizationToolbox`CommonFunctions`"];

Unconstrained::step = "Negative step length (`1`) found. Check direction or change line search parameters.";

Unconstrained::bracket = "Unable to locate minimum in interval `1`.";



DescentDirectionCheck::usage = "DescentDirectionCheck[f, pt, d, vars] Checks to see if a given direction is a descent direction for function f. pt = current design point, d = direction vector, and vars = list of variables. The function returns {\[Del]f.d, status} where \[Del]f.d is the dot product of the gradient vector and the given direction vector and the status is either Descent or NotDescent.";

PlotSearchPath::usage="PlotSearchPath[f, {x1, x1min, x1max}, {x2, x2min, x2max}, hist, opts] shows complete search path superimposed on a contour plot of the function f over the specified range. hist is assumed to be of the form {pt1, pt2, \[Ellipsis]}, where pt1 = {x1,x2} is the first point, etc. The function accepts all relevant options of the standard ContourPlot and the Graphics functions.";



AnalyticalLineSearch::usage = "AnalyticalLineSearch[gradf, pt, d, vars, prResults:True, opts] computes optimum step length using the analytical approach. gradf = gradient of given function, pt = current design point, d = direction vector, vars = list of variables. See Options[AnalyticalLineSearch] for valid options and their usage.";

Options[AnalyticalLineSearch] = {
	SecantPoints->{0, .1},
	StepLengthVar->\[Alpha]};

SecantPoints::usage="SecantPoints is an option for AnalyticalLineSearch. This option is used to specify two initial values to start the Secant method for finding the root. Default {0,.1}.";

StepLengthVar::usage = "StepLengthVar is an option for several unconstrained optimization methods. It specifies the symbol used for the step length variable. Default is StepLengthVar->\[Alpha].";

EqualIntervalSearch::usage = "EqualIntervalSearch[\[Phi], \[Alpha], {\[Alpha]i, \[Delta], F}, tol:10^(-3)] - Determines minimum of \[Phi](\[Alpha]) using Equal Interval Search. Arguments have the following meaning. \[Phi] = function of single variable \[Alpha], {\[Alpha]i, \[Delta], F} initial value of \[Alpha], \[Delta] = initial delta, and F = refinement factor, respectively,  tol (optional) = convergence tolerance (default is 10^(-3)). The function returns {Estimated minimum point, Interval containing minimum}.";

SectionSearch::usage = "SectionSearch[\[Phi], \[Alpha], {\[Alpha]i, \[Delta]},tol:10^(-3)] - Determines minimum of \[Phi](\[Alpha]) using Section Search. Arguments have the following meaning. \[Phi] = function of single variable \[Alpha], {\[Alpha]i, \[Delta]} initial value of \[Alpha], \[Delta] = initial delta. tol (optional) = convergence tolerance (default is 10^(-3)). The function returns {Estimated minimum point, Interval containing minimum}.";

GoldenSectionSearch::usage = "GoldenSectionSearch[\[Phi], \[Alpha], {\[Alpha]i, \[Delta]},tol:10^(-3),prResults_:True] - Determines minimum of \[Phi](\[Alpha]) using golden section search. Arguments have the following meaning. \[Phi] = function of single variable \[Alpha], {\[Alpha]i, \[Delta]} initial value of \[Alpha], \[Delta] = initial delta. tol (optional) = convergence tolerance (default is 10^(-3)). prResults (optional) = If True (default) prints all intermediate results. The function returns {Estimated minimum point, Interval containing minimum}.";

QuadraticSearch::usage = "QuadraticSearch[\[Phi], \[Alpha], \[Delta]:1, maxIter:20, tol:0.001, prResults:True] - Determines minimum of \[Phi](\[Alpha]) using the quadratic interpolation method. \[Phi] = function of single variable \[Alpha], \[Delta] (default = 1) parameter used to establish three initial values of \[Alpha], maxIter (optional) = maximum number of iterations allowed (default = 20), tol (optional) = convergence tolerance (default is 10^(-3)). prResults (optional) = If True (default) prints all intermediate results. The function returns {Estimated minimum point, Interval containing minimum}.";

ArmijoLineSearch::usage = "ArmijoLineSearch[\[Phi], \[Alpha], \[Epsilon], \[Eta], options] - performs line search using Armijo's rule. Arguments have the following meaning. \[Phi] = function of single variable \[Alpha].  \[Epsilon] and \[Eta] are the two parameters. There are two optional parameters. The first is prResults (default True) to control printing of intermediate results. The second is the MaxIterations allowed. The default is MaxIterations set for the FindMinimum function. The functions returns approximate step length.";



SteepestDescent::usage = "SteepestDescent[f, vars, x0, opts]. Computes a minimum of f(vars) starting from x0 using the steepest descent method. The step length is computed using analytical line search. See Options[SteepestDescent] to see a list of options for the function. The function returns {x, hist}. x is either the optimum point or the next point after MaxIterations. hist contains history of values tried at different iterations.";

Options[SteepestDescent] = {PrintLevel->1,
	MaxIterations->50,
	ConvergenceTolerance->0.01,
	StepLengthVar->\[Alpha]};



ConjugateGradient::usage = "ConjugateGradient[f, vars, x0, opts]. Computes minimum of f(vars) starting from x0 using the conjugate gradient method. The user has the option of using either the PolakRibiere (default) or the FletcherReeves method. Also, step length can be computed using either the analytical line search or the approximate line search using the Armijo's rule. See Options[ConjugateGradient] to see a list of options for the function. The function returns {x, hist}. x is either the optimum point or the next point after MaxIterations. hist contains the history of values tried at different iterations.";

Options[ConjugateGradient] = {PrintLevel->1,
	Gradient->Automatic,
	MaxIterations->50,
	ConvergenceTolerance->0.01,
	StepLengthVar->\[Alpha],
	Method->PolakRibiere,
	LineSearch->Analytical,ArmijoParameters->{0.2,2}};

Gradient::usage = "Gradient is an option for several optimization algorithms. It specifies whether the gradient vector is to be computed automatically by direct differentiation (Gradient->Automatic) or by using finite differences (Gradient->Numerical). Analytical gradient vector can be given by entering Gradient->{grad vector}. The default is Automatic.";

Method::usage = "Method is an option for several unconstrained optimization algorithms. It specifies the method used in direction finding. With ConjugateGradient the options are the PolakRibiere (default) and the FletcherReeves. With QuasiNewtonMethod the options are the BFGS (default) and the DFP.";

LineSearch::usage = "LineSearch is an option for several unconstrained optimization algorithms. If specified as Analytical, the analytical line search is used during step length. Other valid options are ArmijoLineSearch, GoldenSectionSearch, and QuadraticSearch. The default is LineSearch->Analytical.";

ArmijoParameters::usage = "ArmijoParameters is an option for several unconstrained optimization algorithms. The specified parameters are used only if Approximate line search is specified. The default is ArmijoParameters->{0.2,2}.";



ModifiedNewton::usage = "ModifiedNewton[f, vars, x0, opts]. Computes minimum of f(vars) starting from x0 using the modified Newton method. See Options[ModifiedNewton] to see a list of options for the function. The function returns {x, hist}. x is either the optimum point or the next point after MaxIterations. hist contains the history of values tried at different iterations.";

Options[ModifiedNewton] = {PrintLevel->1,
	MaxIterations->50,
	ConvergenceTolerance->0.01,
	StepLengthVar->\[Alpha]};



QuasiNewtonMethod::usage = "QuasiNewtonMethod[f, vars, x0, opts]. Computes a minimum of f(vars) starting from x0 using a Quasi-Newton method. The user has the option of using either the BFGS (default) or the DFP method. Also step length can be computed using either the analytical line search or the approximate line search using the Armijo's rule. The number of iterations after which the inverse hessian approximation is reset to identity matrix can be specified using the ResetHessian option. The default is Automatic in which case the reset interval is set to the number of variables. See Options[QuasiNewtonMethod] to see a list of options for the function. The function returns {x, hist}. x is either the optimum point or the next point after MaxIterations. hist contains the history of values tried at different iterations.";

Options[QuasiNewtonMethod] = {PrintLevel->1,
	Gradient->Automatic,
	MaxIterations->50,
	ConvergenceTolerance->0.01,
	StepLengthVar->\[Alpha],
	Method->BFGS,
	LineSearch->Analytical,ArmijoParameters->{0.2,2},
	ResetHessian->Automatic};

ResetHessian::usage = "ResetHessian is an option for QuasiNewtonMethod. It controls the number of iterations after which the inverse hessian approximation is reset to identity matrix. The default is Automatic in which case the reset interval is set to the number of variables.";



Begin["`Private`"];

Needs["Utilities`FilterOptions`"];





DescentDirectionCheck[f_, pt_, d_, vars_] := 
	Module [{gradf=Grad[f,vars],c, dc, ans},
		c = gradf /. ToRules[vars==pt];
		dc = N[d.c];
		ans = If [dc<0, "Descent", "NotDescent"];
		PrintLabelledList[{gradf,c,dc,ans},
			{"\[Del]f","\[Del]f"<>ToString[N[pt]],"\[Del]f.d","Status"},2];
		{ans, dc}
	];

PlotSearchPath[f_, {x1_, x1min_, x1max_}, {x2_, x2min_, x2max_}, hist_, 
opts___?OptionQ] :=
Module[{xhist, fvals, obj1,obj2, pts},
	pts = PlotPoints /. {opts} /. Options[ContourPlot];
	xhist = ListPlot[hist,
		Evaluate[FilterOptions[ListPlot,opts]],
		PlotJoined->True,
		PlotRange->{{x1min,x1max},{x2min,x2max}},
		AspectRatio->1,
		DisplayFunction -> Identity];
	fvals = Map[f/.ToRules[{x1,x2}==#]&,hist];
	If[Length[fvals]>5,fvals=fvals[[{1,2,3,4,5}]]];
	obj1 = ContourPlot[f,{x1, x1min, x1max},
		{x2, x2min, x2max},
		Contours->fvals,
		Evaluate[FilterOptions[ContourPlot,opts]],
		PlotRange->All,AspectRatio->1,
		ContourShading->False,PlotPoints->pts,
		ContourStyle->{{RGBColor[0,0,1]}},		
		DisplayFunction -> Identity];
	obj2 = ContourPlot[f,{x1, x1min, x1max},
		{x2, x2min, x2max},
		Evaluate[FilterOptions[ContourPlot,opts]],
		Contours->5,
		PlotRange->All,AspectRatio->1,
		ContourShading->False,PlotPoints->pts,
		ContourStyle->{{RGBColor[0,0,1]}},		
		DisplayFunction -> Identity];
	Show[{Graphics[obj1],Graphics[obj2],xhist},
			Evaluate[FilterOptions[Graphics,opts]],
			AxesLabel->{x1, x2},Axes->True,AspectRatio->1,
			TextStyle->{FontFamily->"Times",FontSize->10},
			DisplayFunction -> $DisplayFunction]
];		 

PrintUnconstrainedresults[iter_,pt_,dir_,items_:3]:=
Module[{},
	Print["***** Iteration "<>
		ToString[iter]<>" ***** Current point"-> pt];
	Print["Direction-finding phase:"];
	PrintLabelledList[dir[[1]],dir[[2]],items];
	Print["Step-length calculation phase:"];
]



AnalyticalLineSearch[gradf_, pt_, d_, vars_, prResults_:True,
	opts___?OptionQ] := 
	Module [{stepVar, c, dc, step, xk1, pt1, pt2, maxIter},
		{stepVar,{pt1, pt2}}={
			StepLengthVar, SecantPoints}/.Flatten[{opts,
				Options[AnalyticalLineSearch]}];
		maxIter = MaxIterations/.Options[FindRoot];
		xk1 = pt + stepVar d;
		c = gradf /. ToRules[vars==xk1];
		dc = d.c;
		step = stepVar/.FindRoot[Evaluate[dc==0],
			Evaluate[{stepVar,pt1, pt2}],MaxIterations->maxIter,
			Evaluate[FilterOptions[FindRoot,opts]]];
		If[Negative[step],
			Message[Unconstrained::step,step,
			PrintLabelledList[{xk1,Simplify[c],Simplify[dc]==0,step},
			{"xk1","\[Del]f(xk1)","d\[Phi]/d\[Alpha] \[Congruent] \[Del]f(xk1).d=0",stepVar},1]];
		];		
		If[prResults,
			PrintLabelledList[{xk1,Simplify[c],Simplify[dc]==0,step},
			{"xk1","\[Del]f(xk1)","d\[Phi]/d\[Alpha] \[Congruent] \[Del]f(xk1).d=0",stepVar},1]
		];
		step
	];



EqualIntervalSearch[f_,a_,{ai_,d_,F_},tol_:10^(-3)] := 
Module[{al, au, intermedVals, soln},
	{al, au, intermedVals} = getBounds[f,a,{ai,d}];
	Print["\[Delta]"->d];
	Print[TableForm[intermedVals]];						
	Print["Bounds"->{al, au}];						
	If [(au - al) > tol, 	
		{soln,{al, au}} = 
		EqualIntervalSearch[f,a,{al,d/F,F},tol]
	];
	{(al+au)/2,{al, au}} 
];

getBounds[f_,a_,{ai_,d_}] := 
Module[{f1, f2, done=False, a1, a2,
	intermedVals={{"", "\[Alpha]", "\[Phi](\[Alpha])"}}},
	a1 = ai;
	f1 = f /. a->a1;
	AppendTo[intermedVals, {"", a1, f1}];
	While [Not[done],
		a2 = a1 + d; 
		f2 = f /. a->a2;
		AppendTo[intermedVals, {"", a2, f2}];
		If [f2 > f1, done=True, a1=a2; f1=f2];
		If[a2>10^5,
			Message[Unconstrained::bracket,{ai, a2}];
			Abort[]
		] 
	];
	{a1-d, a2, intermedVals}
];




SectionSearch[f_,a_,{ai_,d_},tol_:10^(-3)] := 
Module[{al, au, hist, soln},
	{al, au, hist} = getBounds[f,a,{ai,d}];
	Print["******** Bounding phase ********"];
	Print["\[Delta]"->d];
	Print[TableForm[hist]];						
	Print["Bounds"->{al, au}];						
	Print["******** Refinement phase ********"];		
	hist={{mySubscript["\[Alpha]","L"],mySubscript["\[Alpha]","U"],mySubscript["\[Alpha]","a"], 
		mySubscript["\[Alpha]","b"],"\[Phi](\[Alpha]a)","\[Phi](\[Alpha]b)","I"}}; 
	{{al, au}, soln,hist}=
		doRefinement[f,a,{al,au},tol,hist];
	Print[MatrixForm[hist]]; {soln,{al, au}}
];

doRefinement[f_,a_,{al_,au_},tol_,hist_] := 
Module[{i, fa, fb,aa, ab, newInterval, soln, results=hist},
	i = au - al;
	aa = al + 1/3 i;
	ab = al + 2/3 i; 
	fa = f /. a->aa;
	fb = f /. a->ab;
	If[fa < fb, newInterval = {al, ab}, 
	newInterval = {aa, au}];
	AppendTo[results,{al, au, aa, ab, fa, fb,i}]; 
	If [i > tol, 
		{newInterval, soln,results} = 
		doRefinement[f,a,newInterval,tol,results],   
		{newInterval, Apply[Plus,newInterval]/2,results}
	]
];					



GoldenSectionSearch[f_,a_,{ai_,d_},tol_:10^(-3), prResults_:True] := 
Module[{al, au, hist},
	{al, au, hist} = getGoldenBounds[f,a,{ai,d}];
	If[prResults, Print["******** Bounding phase ********"];
		Print["\[Delta]"->d];
		Print[TableForm[hist]];
		Print["Bounds"->{al,au}]
	];
	{soln,{al,au},hist} = doGoldenRefinement[f,a,{al,au},tol];
	If[prResults, Print["******** Refinement phase ********"];		
		Print[MatrixForm[hist]]
	];
	soln						
];

getGoldenBounds[f_,a_,{ai_,d_}] := 
Module[{n=0,f1, f2, done=False, a1, a2,t = N[GoldenRatio],
	hist={{"", "\[Alpha]", "\[Phi](\[Alpha])"}}},
	a1 = ai;
	f1 = f /. a->a1;
	AppendTo[hist, {"", a1, f1}];
	While [Not[done],
		If[a2>10^5,
			Message[Unconstrained::bracket,{a1-t^(n-2)d, a2}];
			Abort[]
		]; 
		n = n + 1;
		a2 = a1 + t^(n-1) d;
		f2 = f /. a->a2;
		AppendTo[hist, {"", a2, f2}];
		If [f2 > f1, done=True, a1=a2; f1=f2]
	];
	{Max[ai,a1-t^(n-2)d], a2, hist}
];

doGoldenRefinement[f_,a_,{aLower_,aUpper_},tol_] := 
Module[{tau = N[1/GoldenRatio],
	al = aLower, au = aUpper,
	done=False, i, aa, ab, fa, fb,hist},
	hist={{mySubscript["\[Alpha]","L"],mySubscript["\[Alpha]","U"],mySubscript["\[Alpha]","a"], 
		mySubscript["\[Alpha]","b"],"\[Phi](\[Alpha]a)","\[Phi](\[Alpha]b)","I"}}; 
	i = au - al;
	aa = al + (1-tau)  i;
	ab = al + tau i;
	fa = f /. a->aa;
	fb = f /. a->ab;
	AppendTo[hist,{al, au,aa,ab,fa,fb,i}]; 
	While [Not[done],
		If[fa < fb, 
			au = ab; ab = aa; fb = fa; i = au - al;
			aa = al + (1-tau) i; fa = f /. a->aa, 
			al = aa; aa = ab; fa = fb; i = au - al;
			ab = al + tau i; fb = f /. a->ab
		];
		AppendTo[hist,{al, au, aa,ab,fa,fb,i}]; 
		If [i <= tol, done=True]
	];
	{(au+al)/2, {al,au}, hist}
];



QuadraticSearch[\[Phi]_, \[Alpha]_, \[Delta]0_:1, maxIter_:20,
tol_:0.001, prResults_:True] := 
Module[{\[Alpha]1, \[Alpha]2, f\[Alpha]1, f\[Alpha]2, al, am, au, aq, fl, fm, fu, fq,
hist, i, done=False, iter=0,\[Delta] = N[\[Delta]0], conv},
	hist={{mySubscript["\[Alpha]","\[ScriptL]"],mySubscript["\[Alpha]","m"],mySubscript["\[Alpha]","u"],
		mySubscript["\[Alpha]","q"] ,mySubscript["\[Phi]","\[ScriptL]"],
		mySubscript["\[Phi]","m"],mySubscript["\[Phi]","u"],
		mySubscript["\[Phi]","q"],"Conv."}};
	al = 0.; fl = \[Phi]/.\[Alpha]->al;
	\[Alpha]1 = \[Delta]; f\[Alpha]1 = \[Phi]/.\[Alpha]->\[Alpha]1;
	While[And[Not[done],++iter\[LessEqual]maxIter],
		If[prResults,
			Print["**** Iteration ", iter];
			PrintLabelledList[{al, fl, \[Alpha]1, f\[Alpha]1},
			{mySubscript["\[Alpha]","\[ScriptL]"],mySubscript["\[Phi]","\[ScriptL]"], mySubscript["\[Alpha]","1"],
			mySubscript["\[Phi]","1"]},4]
		];
		If[f\[Alpha]1>fl,
			au = \[Alpha]1; fu = \[Phi]/.\[Alpha]->au; 
			am = \[Delta]/2; fm = \[Phi]/.\[Alpha]->am; 
			If[(fl+fu)>(2 fm), done = True,
				\[Delta] = 2\[Delta]; \[Alpha]1 = \[Delta]; f\[Alpha]1 = \[Phi]/.\[Alpha]->\[Alpha]1
			],
			am = \[Alpha]1; fm = \[Phi]/.\[Alpha]->am; \[Alpha]2 = 2\[Delta]; f\[Alpha]2 = \[Phi]/.\[Alpha]->\[Alpha]2;
			If[prResults,PrintLabelledList[{\[Alpha]2, f\[Alpha]2},
				{mySubscript["\[Alpha]","2"],mySubscript["\[Phi]","2"]},2]
			];
			If[f\[Alpha]2>f\[Alpha]1,
				au=\[Alpha]2; fu = \[Phi]/.\[Alpha]->au;
				If[(fl+fu)>(2 fm), done = True,
					\[Delta] = 2\[Delta]; \[Alpha]1 = \[Delta]; f\[Alpha]1 = \[Phi]/.\[Alpha]->\[Alpha]1
				],
				\[Alpha]1=\[Alpha]2; f\[Alpha]1 = f\[Alpha]2; \[Delta] = 2\[Delta]
			]
		];
	];
	If[Not[done],
		Message[Unconstrained::bracket,{al,\[Alpha]1}];
		Abort[];
	];
	If[prResults,PrintLabelledList[{{al, am, au},{fl, fm, fu}},
		{"Initial three points", "Function values"}]
	];
	done = False; iter = 0;
	While [And[Not[done],++iter\[LessEqual]maxIter],
		aq = (al^2 (-fm+fu)+am^2 (-fu+fl)+au^2 (-fl+fm))/
			(2(al(-fm+fu) + am(-fu+fl) + au(-fl+fm)));
		hq = fl (aq-am)(aq-au)/((al-am)(al-au)) + 
			fm (aq-al)(aq-au)/((am-al)(am-au)) +
			fu (aq-al)(aq-am)/((au-al)(au-am));
		fq = \[Phi]/.\[Alpha]->aq;
		conv = Abs[(hq-fq)/fq];
		AppendTo[hist,{al, am, au, aq,fl, fm, fu,fq,conv}]; 
		If[aq \[LessEqual] am,
			If[fm\[LessEqual]fq, al=aq; fl=fq, au=am; fu=fm; am = aq; fm=fq],
			If[fm\[LessEqual]fq, au=aq; fu=fq, al=am;fl=fm; am = aq; fm=fq]
		];
		i = au - al;
		If [conv <= tol, done=True]
	];
	AppendTo[hist,{al, am, au, "--",fl, fm, fu,"--",conv}]; 
	If[prResults,Print[MatrixForm[hist]]];
	aq
];



ArmijoLineSearch[f_, a_, \[Epsilon]_, \[Eta]_, prResults_:True,
	maxIter_:MaxIterations/.Options[FindMinimum]] := 
Module[{iter = 0, f0, fp0, \[Alpha]=1.0, 
	f\[Alpha],hist={{"\[Alpha]","\[Phi](\[Alpha])","\[Phi](0) + \[Alpha]\[Phi]'(0)\[Epsilon]","\[Phi](0) + \[Alpha]\[Phi]'(0)\[Eta]\[Epsilon]"}},t},
	{f0,fp0} = {f,D[f,a]}/.a->0;
	f\[Alpha] = f/.a->\[Alpha];
	t = f0 + \[Alpha] \[Epsilon] fp0;
	AppendTo[hist,{\[Alpha],f\[Alpha],t,"--"}];
	If[prResults,PrintLabelledList[{f0,fp0},{"\[Phi](0)","\[Phi]'(0)"}]];
	If[f\[Alpha] \[LessEqual] t,
		While[And[f\[Alpha] \[LessEqual] t,++iter<maxIter],
			\[Alpha]=\[Eta] \[Alpha]; f\[Alpha] = f/.a->\[Alpha];
			t = f0 + \[Alpha] \[Epsilon] fp0;
			AppendTo[hist,{\[Alpha],f\[Alpha],t,"--"}]
		]; \[Alpha] = \[Alpha]/\[Eta],
		While[And[f\[Alpha] > t,++iter<maxIter],
			\[Alpha]=\[Alpha]/\[Eta]; f\[Alpha] = f/.a->\[Alpha];
			t = f0 + \[Alpha] \[Epsilon] \[Eta] fp0;
			AppendTo[hist,{\[Alpha],f\[Alpha],"--",t}]
		]
	];
	If[iter\[GreaterEqual]maxIter,
		Message[Unconstrained::bracket,{1,t}]
	];
	If[prResults,Print[TableForm[hist]]];
	\[Alpha]
];



SteepestDescent[f_, vars_, x0_, opts___Rule] := 
Module[{iter = 0, x = N[x0], step = 0, d, dNorm,
	eps, maxIter, history={}, fx, dfx, prLevel, 
	prSetup, prResults, gradf},
	{prLevel, maxIter, eps} = {PrintLevel,
		MaxIterations,ConvergenceTolerance} /.
		Flatten[{opts,Options[SteepestDescent]}];
	gradf=Grad[f,vars];
	Switch[prLevel,
		0, {prSetup, prResults}={False, False}, 
		1, {prSetup, prResults}={True, False}, 
		_, {prSetup, prResults}={True, True}
	];
	If[prSetup, 
		PrintLabelledList[{f,gradf},{"f","\[Del]f"},1]
	];
	AppendTo[history, {"x", "d","||\[Del]f(x)||","f(x)"}];
	fx =f/.ToRules[vars == x0];
	dfx = gradf/.ToRules[vars == x0];
	d = -dfx; 
    dNorm = Norm[d];
	While [dNorm > eps && ++iter \[LessEqual] maxIter,
		If[prResults,PrintUnconstrainedresults[iter,x,{{dfx,d, dNorm, fx},
			{"\[Del]f(x)","d","||\[Del]f(x)||","f(x)"}},2]];
		step = AnalyticalLineSearch[gradf, x, d, vars,prResults,opts];
		AppendTo[history,{x, d, dNorm, fx}];
		x = x + step d;
		fx =f/.ToRules[vars == x];
		dfx = gradf/.ToRules[vars == x];
		d = -dfx; 
     	dNorm = Norm[d];
	];
	AppendTo[history,{x, d, dNorm, fx}];
	If[prSetup, 
		If [dNorm >= eps, Print["New Point (Non-Optimum): ",
			x, " after ",iter-1, " iterations"],
			Print["Optimum: ",x, " after ", iter," iterations"]
		]
	];
	{{fx,Thread[vars->x]},history}
]  



ConjugateGradient[f_, vars_, x0_, opts___?OptionQ] :=
Module[{iter = 0, d, x = x0, step = 0, dNorm, cNorm,
	beta, prevCNorm, prevD, c, method, line, prevC,
	eps, maxIter, history={}, fx, prLevel, prSetup, prResults,
	gradient, gradfEx="Numerical", gradf,stepVar,\[Epsilon],\[Eta]},
	{prLevel, gradient, maxIter, eps, stepVar, method, line,{\[Epsilon],\[Eta]}} =
	{PrintLevel, Gradient,
	MaxIterations,ConvergenceTolerance, StepLengthVar, Method,
	LineSearch, ArmijoParameters} /. {opts} /. Options[ConjugateGradient];

	Switch[ToString[gradient],
		"Automatic", gradfEx=Grad[f,vars];gradf[pt_]:=gradfEx/.Thread[vars->pt],
		"Numerical", If[line===Analytical,line = ArmijoLineSearch];
			 gradf[pt_]:=Grad[f,vars,pt],
		_, gradfEx=gradient;gradf[pt_]:=gradfEx/.Thread[vars->pt]
	];
	Switch[prLevel,
		0, {prSetup, prResults}={False, False}, 
		1, {prSetup, prResults}={True, False}, 
		_, {prSetup, prResults}={True, True}
	];
	If[prSetup, 
		PrintLabelledList[{f,gradfEx},{"f","\[Del]f"},1];
		Print["Using the "<>ToString[method]<> " method with "<>
		ToString[line]<>" line search"]
	];
	AppendTo[history, {"x", "d","||\[Del]f(x)||","f(x)","\[Beta]"}];
	fx =f/.ToRules[vars == x0];
	c = gradf[x0];
    prevD = Table[0,{Length[vars]}];
	prevC = c;
    prevCNorm = dNorm = cNorm = Norm[c];
	While [cNorm > eps && ++iter \[LessEqual] maxIter,
		fx =f/.ToRules[vars == x];
		c = gradf[x];
		cNorm = Norm[c];
		If[method===FletcherReeves,
			beta = c.c/(prevC.prevC),
			beta = (c-prevC).c/(prevC.prevC)
		]; 
		d = -c + beta prevD; 
     	dNorm = Norm[d];
		If[prResults,PrintUnconstrainedresults[iter,x,
			{{c, d, cNorm, beta,fx},
			{"\[Del]f(x)","d", "||\[Del]f(x)||","\[Beta]","f(x)"}},2]];
		Switch[line,
			Analytical, step = AnalyticalLineSearch[gradfEx, x, d, 
				vars, prResults,opts],
			GoldenSectionSearch, step = 
				GoldenSectionSearch[f/.ToRules[vars==x+stepVar d],
				stepVar,{0,.1},0.001,prResults], 
			QuadraticSearch, step = 
				QuadraticSearch[f/.ToRules[vars==x+stepVar d],
				stepVar,1,20,0.001,prResults], 
			_, step = ArmijoLineSearch[f/.ToRules[vars==x+stepVar d],
				stepVar,\[Epsilon],\[Eta],prResults]
		];
		AppendTo[history,{x, d, cNorm,fx, beta}];
		x = x + step d;
		prevCNorm = cNorm;
		prevC = c;
		prevD = d;
	];
	fx =f/.ToRules[vars == x];
	c = gradf[x];
	AppendTo[history,{x, "--", Norm[c],fx,"--"}];
	If[prSetup, 
		If [cNorm >= eps, Print["New Point (NonOptimum): ",
			x, " after ",iter-1, " iterations"],
			Print["Optimum: ",x, " after ", iter," iterations"]
		]
	];
	{{fx,Thread[vars->x]},history}
];  



ModifiedNewton[f_, vars_, x0_, opts___?OptionQ] := 			
Module[{iter = 0, d, x = x0, step=0, cNorm=10^10, H,fx, 
	c, hessian=Hessian[f,vars], gradf = Grad[f,vars],stepVar,
	eps, maxIter, history={}, prLevel, prSetup, prResults},
	{prLevel, maxIter, eps, stepVar} = {PrintLevel,
	MaxIterations,ConvergenceTolerance,
	StepLengthVar} /. Flatten[{opts, Options[ModifiedNewton]}];
	Switch[prLevel,
		0, {prSetup, prResults}={False, False}, 
		1, {prSetup, prResults}={True, False}, 
		_, {prSetup, prResults}={True, True}
	];
	If[prSetup, 
		PrintLabelledList[{f,gradf,hessian},{"f","\[Del]f", "\!\(TraditionalForm\`\[Del]\^2\)f"},1]
	];
	AppendTo[history, {"x", "d","||\[Del]f(x)||","f(x)"}];
	While [cNorm > eps && ++iter \[LessEqual] maxIter,
		{fx,c,H} = {f, gradf, hessian} /. ToRules[vars == x];
     	cNorm = Norm[c];
        d = LinearSolve[H ,-c];
		If[prResults,PrintUnconstrainedresults[iter,x,
			{{H, c, cNorm, fx, {d}},
			{"\!\(TraditionalForm\`\[Del]\^2\)f","\[Del]f(x)", "||\[Del]f(x)||","f(x)","d"}},2]];
		step = AnalyticalLineSearch[gradf, x, d, vars,prResults,opts];
		AppendTo[history,{x, d, cNorm, fx}];
		x = x + step d;
	];
	{fx,c} = {f,gradf} /. ToRules[vars == x];
    cNorm = Norm[c];
	AppendTo[history,{x, "--", cNorm, fx}];
	If[prSetup, 
		If [cNorm >= eps, Print["New Point (NonOptimum): ",
			x, " after ",iter-1, " iterations"],
			Print["Optimum: ",x, " after ", iter," iterations"]
		]
	];
	{{fx,Thread[vars->x]},history}
];  



QuasiNewtonMethod[f_, vars_, x0_, opts___?OptionQ] := 			
Module[{iter = 0, d, x = x0, step=0, cNorm,
	Q=IdentityMatrix[Length[vars]],fx, method, line,j=1, 
	c, gradient, gradfEx="Numerical", gradf,
	stepVar, \[Epsilon], \[Eta], prevC, s, q, Qq, qs, Qqs,
	eps, maxIter, history={}, prLevel, prSetup, prResults},
	{prLevel, gradient, maxIter, eps, stepVar, method, line, {\[Epsilon], \[Eta]}, reset} = 
	{PrintLevel, Gradient, MaxIterations,ConvergenceTolerance,
	StepLengthVar, Method, LineSearch, ArmijoParameters,
	ResetHessian} /. {opts} /. Options[QuasiNewtonMethod];
	If[reset===Automatic, reset=Length[vars]];

	Switch[ToString[gradient],
		"Automatic", gradfEx=Grad[f,vars];gradf[pt_]:=gradfEx/.Thread[vars->pt],
		"Numerical", If[line===Analytical,line = ArmijoLineSearch];
			 gradf[pt_]:=Grad[f,vars,pt],
		_, gradfEx=gradient;gradf[pt_]:=gradfEx/.Thread[vars->pt]
	];

	Switch[prLevel,
		0, {prSetup, prResults}={False, False}, 
		1, {prSetup, prResults}={True, False}, 
		_, {prSetup, prResults}={True, True}
	];
	If[prSetup, 
		PrintLabelledList[{f, gradfEx},{"f","\[Del]f"},1];
		Print["Using the "<>ToString[method]<>
		" method with approximate inverse hessian reset after "<>
		ToString[reset]<>" iterations and "<>ToString[line]<>" line search"]
	];
	AppendTo[history, {"x", "d","||\[Del]f(x)||","f(x)","Inverse Hessian"}];
	fx =f/.ToRules[vars == x0];
	c = gradf[x0];
	cNorm = Norm[c];
	While [cNorm > eps && ++iter \[LessEqual] maxIter,
        d = -Q .c;
		If[prResults,PrintUnconstrainedresults[iter,x,
			{{Q, c, cNorm, fx, {d}},
			{"Inverse Hessian","\[Del]f(x)", "||\[Del]f(x)||","f(x)","d"}},2]];
		Switch[line,
			Analytical, step = AnalyticalLineSearch[gradfEx, x, d, 
				vars, prResults,opts],
			GoldenSectionSearch, step = 
				GoldenSectionSearch[f/.ToRules[vars==x+stepVar d],
				stepVar,{0,.1},0.001,prResults], 
			QuadraticSearch, step = 
				QuadraticSearch[f/.ToRules[vars==x+stepVar d],
				stepVar,1,20,0.001,prResults], 
			_, step = ArmijoLineSearch[f/.ToRules[vars==x+stepVar d],
				stepVar,\[Epsilon],\[Eta],prResults]
		];
		AppendTo[history,{x, d, cNorm, fx, Q}];
		s = step d;
		x = x + s;
		prevC = c;
		fx =f/.ToRules[vars == x];
		c = gradf[x];
     	cNorm = Norm[c];
		q = c - prevC;
		If[j < reset,
			++j;
			qs = q.s;
			If [qs >0,
				Qq = Q.q;
				If[prResults,
					Print["Updating inverse hessian:"];
					PrintLabelledList[{q, qs, Qq, 
					Outer[Times,s,s]},
					{"q","qT.s","Q.q","s.sT"},2]
				];
				If[method===DFP,
					Q = Q + Outer[Times,s,s]/qs - 
						Outer[Times,Qq,Qq]/(q.Qq);
					If[prResults,PrintLabelledList[{Outer[Times,Qq,Qq],
						q.Qq, Q},
						{"Q.q.[Q.q]T","q.Q.q", "Q"},1]
					],
					Qqs = Outer[Times,Qq,s]; 
					Q = Q + (1+((q.Qq)/qs))Outer[Times,s,s]/qs - 
						(Transpose[Qqs]+Qqs)/qs;
					If[prResults,PrintLabelledList[{Qqs,
						Transpose[Qqs]+Qqs, Q},
						{"Q.q.sT","[Q.q.sT]T + Q.q.sT", "Q"},1]
					]
				];
			],
			Q=IdentityMatrix[Length[vars]]; j = 1
		];
	];
	AppendTo[history,{x, "--", cNorm, fx, "--"}];
	If[prSetup, 
		If [cNorm >= eps, Print["New Point (NonOptimum): ",
			x, " after ",iter-1, " iterations"],
			Print["Optimum: ",x, " after ", iter," iterations"]
		]
	];
	{{fx,Thread[vars->x]},history}
];  



End[];

EndPackage[]
